package com.wudiware.teketot;

import android.content.Context;
import android.content.res.Resources;
import android.graphics.Bitmap;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Paint;
import android.graphics.Rect;
import android.graphics.Typeface;
import android.graphics.Paint.Align;
import android.media.MediaPlayer;

public class AnimatedSprite {
	public float rotation = 275;
	public float velo = 1;
 public Bitmap animation;
	public int xPos;
	public int yPos;
	private Rect sRectangle;
	private int fps;
	private int numFrames;
	private int currentFrame;
	private long frameTimer;
	private int spriteHeight;
	private int spriteWidth;
	private boolean loop;
	public boolean dispose;
	public MediaPlayer sound;
	public int life = 100;
public int maxlife = 100;
public int mycolor = 0;
public int id = 0;
public int textcolor = Color.BLACK;
	public boolean hastext = false;
	public String mytext = "";
	public Resources res;
	public Typeface tf;
	public int textsize = 50;
	public int place = 0;
	public boolean isgreen = false;
	public int textoffset = 0;
	public String word;
	public int delay = 50;
	public int maxdelay = 50;
	public Context con;
	public Typeface ffont;
	
	public AnimatedSprite() {
		sRectangle = new Rect(0, 0, 0, 0);
		frameTimer = 0;
		currentFrame = 0;
		xPos = 80;
		yPos = 200;
		dispose = false;
		
	}
	
	public void Initialize(Bitmap bitmap, int height, int width, int fps, int frameCount, boolean loop) {
		this.animation = bitmap;
		this.spriteHeight = height;
		this.spriteWidth = width;
		this.sRectangle.top = 0;
		this.sRectangle.bottom = spriteHeight;
		this.sRectangle.left = 0;
		this.sRectangle.right = spriteWidth;
		this.fps = 1000 / fps;
		this.numFrames = frameCount;
		this.loop = loop;
	}
	
	public Boolean recthit(float x, float y){
		
		if( x >= xPos && x <= xPos + spriteWidth  && y >= yPos && y <= yPos + spriteHeight  )
		{ 
			
			
			return true;
		}
		
		return false;
		
	}
	
	public int getWidth(){
		return spriteWidth;
		
	}
	public int getHeight(){
		return spriteHeight;
		
	}
	
	public void setdelay(int v){
		delay = v;
		maxdelay = v;
		
		
	}
	public int getXPos() {
		return xPos;
	}
	
	public int getYPos() {
		return yPos;
	}
	
	public void setXPos(int value) {
		xPos = value - (spriteWidth/2);
	}
	
	public void setYPos(int value) {
		yPos = value - (spriteHeight/2);
	}
	
	
	public void Update(long gameTime) {
		if( gameTime > frameTimer + fps) {
			frameTimer = gameTime;
			currentFrame += 1;
			
			if( currentFrame >= numFrames ) {
				currentFrame = 0;
				
				if(!loop)
					dispose = true;			
				
			}
			
			sRectangle.left = currentFrame * spriteWidth;
			sRectangle.right = sRectangle.left + spriteWidth;
		}
	}
	
	public void draw(Canvas canvas) {
		Rect dest = new Rect(getXPos(), getYPos(), getXPos() + spriteWidth,
										getYPos() + spriteHeight);
		canvas.drawBitmap(animation, sRectangle, dest, null);

		if(hastext){	
		Paint np = new Paint();
		
		//np.setARGB(255, 0, 0, 0);
		np.setColor(textcolor);
		np.setTextAlign(Align.CENTER);
		if(ffont != null){ 
		np.setTypeface(ffont);
		}
		
		
		np.setTextSize(textsize);
		canvas.drawText(mytext, xPos + animation.getWidth()/2, yPos  + textoffset + animation.getHeight()/2, np);}
	
	}
}
