/*
 * Copyright (C) 2007 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package com.wudiware.teketot;

import java.io.IOException;
import java.util.ArrayList;

import android.view.WindowManager;





import android.content.Context;
import android.content.res.Resources;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Paint;
import android.graphics.Typeface;
import android.media.MediaPlayer;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.util.AttributeSet;
import android.util.DisplayMetrics;
import android.util.Log;
import android.view.Display;
import android.view.MotionEvent;
import android.view.SurfaceHolder;
import android.view.SurfaceView;
import android.view.View;
import android.widget.TextView;


/**
 * View that draws, takes keystrokes, etc. for a simple LunarLander game.
 * 
 * Has a mode which RUNNING, PAUSED, etc. Has a x, y, dx, dy, ... capturing the
 * current ship physics. All x/y etc. are measured with (0,0) at the lower left.
 * updatePhysics() advances the physics based on realtime. draw() renders the
 * ship, and does an invalidate() to prompt another draw() as soon as possible
 * by the system.
 */
class AnimationView extends SurfaceView implements SurfaceHolder.Callback {
   
	public int sizz =0;
	class AnimationThread extends Thread {
    	
    	public int numobj = 0;
    	public int currentnumber = 0;
    	public boolean gamechange = false;
    	
    	public double oh = 850;
    	public double ow = 1400;
    	public double tw = 0;
    	public double th = 0;
    	public double dw  =0;
    	public double dh = 0;
    	public MediaPlayer seexcellent;
    	public MediaPlayer segoodjob;
    	public MediaPlayer senicework;
    	public MediaPlayer sethatsright;
    	public MediaPlayer seclapping;
    	public MediaPlayer secorrect;
    	public MediaPlayer seoops;
    	public MediaPlayer intro;
    	public MediaPlayer a1;
    	public MediaPlayer a2;
    	public MediaPlayer a3;
    	public MediaPlayer a4;
    	public MediaPlayer a5;
    	public MediaPlayer a6;
    	public MediaPlayer a7;
    	public MediaPlayer a8;
    	public MediaPlayer a9;
    	public MediaPlayer a10;
    	public MediaPlayer a11;
    	public MediaPlayer a12;
    	public MediaPlayer a13;
    	public MediaPlayer a14;
    	public MediaPlayer a15;
    	public MediaPlayer a16;
    	public MediaPlayer a17;
    	public MediaPlayer a18;
    	public MediaPlayer a19;
    	public MediaPlayer a20;
    	
    	
    	
    	
    	
    	
    	public MediaPlayer sea;
    	public MediaPlayer seb;
    	public MediaPlayer sec;
    	public MediaPlayer sed;
    	public MediaPlayer see;
    	public MediaPlayer sef;
    	public MediaPlayer seg;
    	public MediaPlayer seh;
    	public MediaPlayer sei;
    	public MediaPlayer sej;
    	public MediaPlayer sek;
    	public MediaPlayer sel;
    	public MediaPlayer sem;
    	public MediaPlayer sen;
    	public MediaPlayer seo;
    	public MediaPlayer sep;
    	public MediaPlayer seq;
    	public MediaPlayer ser;
    	public MediaPlayer ses;
    	public MediaPlayer set;
    	public MediaPlayer seu;
    	public MediaPlayer sev;
    	public MediaPlayer sew;
    	public MediaPlayer sex;
    	public MediaPlayer sey;
    	public MediaPlayer sez;
    	
    	public MediaPlayer tsound;
    	
    	public MediaPlayer find;
    	
    	
    	
    	public MediaPlayer tse1;
    	public MediaPlayer tse2;
    	public MediaPlayer tse3;
    	public MediaPlayer tse4;
    	public MediaPlayer tse5;
    	
    	
    	public int maxdots = 8;
    	
    	public Typeface myfont;
    	
    	public MediaPlayer getitright1;
    	public MediaPlayer getitright2;
    	public MediaPlayer getitright3;
    	public MediaPlayer getitright4;
    	
    	public MediaPlayer getitwrong1;
    	public MediaPlayer getitwrong2;
    	public MediaPlayer getitwrong3;
    	public MediaPlayer getitwrong4;
    	
    	public long pause = 0;
    	
    	
    	public int spacer = 0;
    	
    	
    	
    	public int otype = 0;
    	public int otratype = 0;
    	public int level =1;
    	public int cgame = 0;
    	
    	public int maxabcgames = 6;
    	public int maxdraggames = 4;
    	
    	public int ans;
    	public int oans;
    	
    	public boolean menubuttonloaded = false;
    	
    	public boolean touchdown = false;
    	public boolean movedot = false;
    	
    	
    	public float tx =0;
    	
    	public float ty = 0;
    	
    	
    	
    	
    	public int levelbuttonsoffset =0;
    	public int topmenuoffset=0;
    	public int amenuoffset = 0;
    	
    	public int score=0;
    	public int hiscore = 0;
    	
    	
    	
    	
    	public AnimatedSprite amenu = new AnimatedSprite();

    	
    	public AnimatedSprite aaa = new AnimatedSprite();
        /*
         * Difficulty setting constants
         */
        public static final int DIFFICULTY_EASY = 0;
        public static final int DIFFICULTY_HARD = 1;
        public static final int DIFFICULTY_MEDIUM = 2;
        
        /*
         * State-tracking constants
         */
        public static final int STATE_LOSE = 1;
        public static final int STATE_PAUSE = 2;
        public static final int STATE_READY = 3;
        public static final int STATE_RUNNING = 4;
        public static final int STATE_WIN = 5;
        public int setup = 0;
        /*
         * UI constants 
         */
        private static final String KEY_DIFFICULTY = "mDifficulty";
        private static final String KEY_WINS = "mWinsInARow";
        
        /*
         * Bitmaps
         */
        private Bitmap ired;
        private Bitmap igreen;
        private Bitmap ired100;
        private Bitmap igreen100;
        
        
        private Bitmap abcs;
        private Bitmap mgetit;
        private Bitmap mcontrolit;
        private Bitmap mchaseit;
        private Bitmap mdragit;
        private Bitmap mmatchit;
        private Bitmap mcountit;
        private Bitmap mmenu;
        private Bitmap outline;
        private Bitmap smile;
        private Bitmap apple;
        private Bitmap banana;
        private Bitmap pig;
        private Bitmap elephant;
        private Bitmap monkey;
        private Bitmap owl;
        private Bitmap penguin;
        private Bitmap babyboy;
        private Bitmap cow;
        private Bitmap blank;
        private Bitmap iconbg;
        
        
        private Bitmap bgreds;
        private Bitmap bggreens;
        private Bitmap bgred;
        private Bitmap bggreen;
        
        private Bitmap blevelred;
        private Bitmap blevelgreen;
        
        private Bitmap mred;
        private Bitmap mgreen;
        
        
        public int abccorrect = 0;
        
        
        
        private Typeface tf ;
        
        /** What to draw for the Lander when it has crashed */
        private ArrayList<AnimatedSprite> mSprites;
        private ArrayList<AnimatedSprite> mSpritestoRemove;
        private ArrayList<AnimatedSprite> lsprites; 
        private ArrayList<AnimatedSprite> abcmenu;
        private ArrayList<AnimatedSprite> choices;
        private ArrayList<AnimatedSprite> words;
        
        /**
         * Current difficulty -- amount of fuel, allowed angle, etc. Default is
         * MEDIUM.
         */
        private int mDifficulty;

        /** Message handler used by thread to interact with TextView */
        private Handler mHandler;

        /** The state of the game. One of READY, RUNNING, PAUSE, LOSE, or WIN */
        private int mMode;

        /** Used to figure out elapsed time between frames */
        private long mLastTime;
        
        /** Indicate whether the surface has been created & is ready to draw */
        private boolean mRun = false;
       
 
        

        /** Handle to the surface manager object we interact with */
        private SurfaceHolder mSurfaceHolder;

        private Paint textPaint;
        
        /** Number of sprites drawed in a row. */
        private int numSprites;
        
        public Resources res;
        
        /**
		 * Draws to the provided Canvas.
		 */
		private void doDraw(Canvas canvas) {
		    // Draw the background image. Operations on the Canvas accumulate
		    // so this is like clearing the screen.
		    //canvas.drawBitmap(mBackgroundImage, 0, 0, null);
			canvas.drawColor(Color.BLACK);
			 
			
			
			synchronized(mSprites){
			for( AnimatedSprite abcz : mSprites){
				abcz.draw(canvas);
			}
			}
		if(amenu != null){	amenu.draw(canvas); }
			
			synchronized(lsprites){
				for( AnimatedSprite l : lsprites){
					l.draw(canvas);
					}
				}       		
				
			synchronized(abcmenu){
				for (AnimatedSprite abc :abcmenu){
					
					abc.draw(canvas);
					
				}
				
			}
			
			
			if(mMode == STATE_RUNNING ){
				
				
				if(score < 0) { score = 0;}
				if(hiscore < score){hiscore = score;}
	
				if(cgame == 2){
				canvas.drawText( "High Score: " + hiscore, getWidth() /2 -50 ,20, textPaint);
				canvas.drawText( "Score: " + score, getWidth()/2 -50, 45, textPaint);
				}
				
				
				
				
				//	canvas.drawText(fps + " fps", getWidth() - 100, getHeight() - 40, textPaint);
		    //	canvas.drawText(numSprites + " sprites", getWidth() - 100, getHeight() - 20, textPaint);
			}
			
			canvas.restore();            
		}

		public AnimationThread(SurfaceHolder surfaceHolder, Context context, Handler handler) {
            // get handles to some important objects
            mSurfaceHolder = surfaceHolder;
            mHandler = handler;
            mContext = context;

            res = context.getResources();
            
            myfont = Typeface.createFromAsset(  res.getAssets(), "fonts/primerb.ttf");
    		
            
            
            
            mSprites = new ArrayList<AnimatedSprite>();                        
            mSpritestoRemove = new ArrayList<AnimatedSprite>();
            lsprites = new ArrayList<AnimatedSprite>();
            abcmenu = new ArrayList<AnimatedSprite>();  
            choices = new ArrayList<AnimatedSprite>();
            words = new ArrayList<AnimatedSprite>();
            
            
           
            textPaint = new Paint();
            textPaint.setARGB(255,255,255,255);
            textPaint.setTextSize(26);
            
           tf = Typeface.createFromAsset(res.getAssets(), "fonts/primerb.ttf");
            
            textPaint.setTypeface(tf);
           if(blank == null){blank = BitmapFactory.decodeStream(res.openRawResource(R.drawable.blank)); }
          
			if(banana == null){banana = BitmapFactory.decodeStream(res.openRawResource(R.drawable.banana)); }
			if(pig == null){pig = BitmapFactory.decodeStream(res.openRawResource(R.drawable.pig)); }
			if(elephant == null){elephant = BitmapFactory.decodeStream(res.openRawResource(R.drawable.elephant)); }
			if(monkey == null){monkey = BitmapFactory.decodeStream(res.openRawResource(R.drawable.monkey)); }
			if(owl == null){owl = BitmapFactory.decodeStream(res.openRawResource(R.drawable.owl)); }
			if(penguin == null){penguin = BitmapFactory.decodeStream(res.openRawResource(R.drawable.penguin)); }
			if(babyboy == null){babyboy = BitmapFactory.decodeStream(res.openRawResource(R.drawable.babyboy)); }
			if(cow == null){cow = BitmapFactory.decodeStream(res.openRawResource(R.drawable.cow)); }
		
		
		/*	
		     if(sea == null || sea.getDuration() < 2){ sea = MediaPlayer.create(mContext, R.raw.a); } 
				if(seb == null || seb.getDuration() < 2){ seb = MediaPlayer.create(mContext, R.raw.b); } 
				if(sec == null || sec.getDuration() < 2) {sec = MediaPlayer.create(mContext, R.raw.c); }
				if(sed == null || sed.getDuration() < 2){sed = MediaPlayer.create(mContext, R.raw.d); }
				if(see == null || see.getDuration() < 2){see = MediaPlayer.create(mContext, R.raw.e); }
				if(sef == null || sef.getDuration() < 2){sef = MediaPlayer.create(mContext, R.raw.f);} 
				if(seg == null || seg.getDuration() < 2){seg = MediaPlayer.create(mContext, R.raw.g);} 
				if(seh == null || seh.getDuration() < 2){seh = MediaPlayer.create(mContext, R.raw.h);} 
				if(sei == null || sei.getDuration() < 2){sei = MediaPlayer.create(mContext, R.raw.i);} 
				if(sej == null || sej.getDuration() < 2){sej = MediaPlayer.create(mContext, R.raw.j); }
				if(sek == null || sek.getDuration() < 2){sek = MediaPlayer.create(mContext, R.raw.k); }
				if(sel == null || sel.getDuration() < 2){sel = MediaPlayer.create(mContext, R.raw.l); }
				if(sem == null || sem.getDuration() < 2){sem = MediaPlayer.create(mContext, R.raw.m); }
				if(sen == null || sen.getDuration() < 2){sen = MediaPlayer.create(mContext, R.raw.n); }
				if(seo == null || seo.getDuration() < 2){seo = MediaPlayer.create(mContext, R.raw.o); }
				if(sep == null || sep.getDuration() < 2){sep = MediaPlayer.create(mContext, R.raw.p); }
				if(seq == null || seq.getDuration() < 2){seq = MediaPlayer.create(mContext, R.raw.q); }
				if(ser == null || ser.getDuration() < 2){ser = MediaPlayer.create(mContext, R.raw.r); }
				if(ses == null || ses.getDuration() < 2){ses = MediaPlayer.create(mContext, R.raw.s); }
				if(set == null || set.getDuration() < 2){set = MediaPlayer.create(mContext, R.raw.t); }
				if(seu == null || seu.getDuration() < 2){seu = MediaPlayer.create(mContext, R.raw.u); }
				if(sev == null || sev.getDuration() < 2){sev = MediaPlayer.create(mContext, R.raw.v); }
				if(sew == null || sew.getDuration() < 2){sew = MediaPlayer.create(mContext, R.raw.w); }
				if(sex == null || sex.getDuration() < 2){sex = MediaPlayer.create(mContext, R.raw.x); }
				if(sey == null || sey.getDuration() < 2){sey = MediaPlayer.create(mContext, R.raw.y); }
				if(sez == null || sez.getDuration() < 2){sez = MediaPlayer.create(mContext, R.raw.z); }
		    
			*/
			
			
			find = MediaPlayer.create(mContext, R.raw.sfind); 
    	
			//sound effects played by words array/playword.
		   		
			
			seoops = MediaPlayer.create(mContext, R.raw.seoops);
    		
		secorrect = MediaPlayer.create(mContext, R.raw.secorrect);
    		
    		seclapping = MediaPlayer.create(mContext, R.raw.seclapping);
    
    		seexcellent = MediaPlayer.create(mContext, R.raw.seexcellent);
    	segoodjob = MediaPlayer.create(mContext, R.raw.segoodjob);
   senicework = MediaPlayer.create(mContext, R.raw.senicework);
    	sethatsright = MediaPlayer.create(mContext, R.raw.sethatsright);
 			
			
			
			
			getitwrong1 = MediaPlayer.create(mContext, R.raw.sred1);
			getitwrong2 = MediaPlayer.create(mContext, R.raw.sred1);
			getitwrong3 = MediaPlayer.create(mContext, R.raw.sred1);
			getitwrong4 = MediaPlayer.create(mContext, R.raw.sred1);
			
			
			
			getitright1=  MediaPlayer.create(mContext, R.raw.sgreen1);
			getitright2=  MediaPlayer.create(mContext, R.raw.sgreen1);
			getitright3=  MediaPlayer.create(mContext, R.raw.sgreen1);
			getitright4=  MediaPlayer.create(mContext, R.raw.sgreen1);

			
           numSprites = 0;
            mDifficulty = DIFFICULTY_MEDIUM;
    
       
		
		}

        @Override
        public void run() {
            while (mRun) {
                Canvas c = null;
                try {
                    c = mSurfaceHolder.lockCanvas(null);
                    synchronized (mSurfaceHolder) {
                       if (mMode == STATE_RUNNING) 
                    	
                    	         doDraw(c);
                    	tw = c.getWidth();
                        th = c.getHeight();
                            
                           		dh = (double) ( th / oh);
                           		dw = (double)( tw / ow);
                         if(dh < dw){dw=dh;}
                         else{dh = dw;}
                    	   
                    	   
                    	   
                    	updatePhysics();
                  
                    }
                } catch(Exception e){
                	System.out.println(e.getStackTrace());
                }finally {
                    // do this in a finally so that if an exception is thrown
                    // during the above, we don't leave the Surface in an
                    // inconsistent state
                    if (c != null) {
                        mSurfaceHolder.unlockCanvasAndPost(c);
                    }
                }
            }
        }
        
        
        public double distance(double x1, double y1, double x2, double y2){
        	
        	
        	return  (Math.sqrt(( (x1 - x2) * (x1 - x2) + (y1 - y2) * (y1 - y2))));
        	
        	
        	
        }
        
		
		public Bitmap getotype(int i) {
			if (i == 1) { return(apple); }
			if (i == 2) { return(banana); }
			if (i == 3) { return(pig); }
			if (i == 4) { return(elephant); }
			if (i == 5) { return(monkey); }
			if (i == 6) { return(owl); }
			if (i == 7) { return(penguin); }
			if (i == 8) { return(babyboy); }
			if (i == 9) { return(cow); }
			
			//This line is here because the function must return a value in all cases.
			return (  apple);
			}
	
		private void addnew(){
	        	
	    	      
	        	
				
				AnimatedSprite a = new AnimatedSprite();
	        	if(mSprites.size() > maxdots) {return;}
				int x =0;
				int y = 0;
	        				
	        			int done = 0;
	        			while(done == 0)
	        				
	        			{
	        				done = 1;
	        			 x = (int) (gw((int)(Math.random() * 1000 + 50)));
	        			y = (int) (gh((int)(Math.random() * 600 + 50)));
	        			
	        		 
	        			synchronized(mSprites){
	        			for( AnimatedSprite aa : mSprites){
	        		 		
	        			//	if( distance( (float) x, (float) y, (float) aa.getXPos() + (float)aa.getWidth()/2, (float) aa.getYPos() + (float)aa.getHeight()/2 ) <  gw(120)){
	        				if( distance( (float) x, (float) y, (float) aa.getXPos() ,(float) aa.getYPos()) < gw(120)){
	        					done = 0;
	        					
	        				
	        				
	        				}
	        			
	        			if(y < gw(155)) {done = 0;}
	        			}
	        				
	        		 	}
	        		 	
	        			}
	        		
	        		
	        		
	        		if(igreen100 == null)
	        			
	        		{
	        			igreen100 = BitmapFactory.decodeStream(res.openRawResource(R.drawable.green100));
	        			igreen100 = Bitmap.createScaledBitmap(igreen100, gw(igreen100.getWidth()),gh(igreen100.getHeight()), false);
	        		}
	        		
	        			if(ired100 == null){
	        				ired100  =BitmapFactory.decodeStream(res.openRawResource(R.drawable.red100));
	        				ired100 = Bitmap.createScaledBitmap(ired100, gw(ired100.getWidth()),gh(ired100.getHeight()), false);
	        		        				
	        				
	        			}
	        			
	        			
	        			int chooser = (int) (Math.random() * 100);
	        			
	        			
	        			a.maxlife = 150 - score;
	        			a.life = a.maxlife;
	        			
	        			if(chooser >50){
	        			a.mycolor = 1;
	        			
	        			 a.sound = MediaPlayer.create(mContext, R.raw.sgreen1);
	        			
	        			
	               a.Initialize(igreen100, igreen100.getHeight(), igreen100.getWidth(),24, 1, true); 
	        		a.setXPos((int)(x + a.getWidth()/2));
	        		a.setYPos((int)(y + a.getHeight()/2));  
	        			}else{
	        				 a.sound = MediaPlayer.create(mContext, R.raw.sred1);
	        				a.mycolor =2;
	        			       a.Initialize(ired100, ired100.getHeight(), ired100.getWidth(),24, 1, true); 
	        		    		a.setXPos((int)(x + a.getWidth() /2));
	        		    		a.setYPos((int)(y+ a.getHeight()/2));  
	        		    				
	        				
	        	
	        			}
	        
	        			//synchronized(mSprites){
	        		//
	        			
	        			//if(setup == 0){
	        		  	synchronized(mSprites){
	        			mSprites.add(a);
	        			//}
	        			
	        			//	}	
	        			}
	        	
	        		}
        	
    
	       public int gh(int v){
	    	return ((int)( dh * v));
	       }
	    
	       public int gw(int v){
	    	   return((int)(dw * v));
	    	   
	       }
	       
        	
        	public void showmenu(){
        		
if(mgetit == null){ mgetit = BitmapFactory.decodeStream(res.openRawResource(R.drawable.mred)); 
mgetit = Bitmap.createScaledBitmap(mgetit, gw(mgetit.getWidth()), gh(mgetit.getHeight()), false);

}
if(mcontrolit == null){ mcontrolit = BitmapFactory.decodeStream(res.openRawResource(R.drawable.mred)); 
mcontrolit = Bitmap.createScaledBitmap(mcontrolit, gw(mcontrolit.getWidth()), gh(mcontrolit.getHeight()), false);
}
if(mchaseit == null){ mchaseit = BitmapFactory.decodeStream(res.openRawResource(R.drawable.mred)); 
mchaseit = Bitmap.createScaledBitmap(mchaseit, gw(mchaseit.getWidth()), gh(mchaseit.getHeight()), false);
}
if(mdragit == null){ mdragit = BitmapFactory.decodeStream(res.openRawResource(R.drawable.mred));
mdragit = Bitmap.createScaledBitmap(mdragit, gw(mdragit.getWidth()), gh(mdragit.getHeight()), false);
}        		
if(mmatchit == null){ mmatchit = BitmapFactory.decodeStream(res.openRawResource(R.drawable.mred));
mmatchit = Bitmap.createScaledBitmap(mmatchit, gw(mmatchit.getWidth()), gh(mmatchit.getHeight()), false);
}        		
if(mcountit == null){ mcountit = BitmapFactory.decodeStream(res.openRawResource(R.drawable.mred)); 
mcountit = Bitmap.createScaledBitmap(mcountit, gw(mcountit.getWidth()), gh(mcountit.getHeight()), false);
}        		
if(abcs == null){ abcs = BitmapFactory.decodeStream(res.openRawResource(R.drawable.mred)); 
abcs = Bitmap.createScaledBitmap(abcs, gw(abcs.getWidth()), gh(abcs.getHeight()), false);
}        		
        		
        		
	synchronized(mSprites)
	{        		
        		int spacer = 20;
        		
        		
        		AnimatedSprite a = new AnimatedSprite();
        		a.Initialize(mgetit, mgetit.getHeight(), mgetit.getWidth(),24, 1, true);
        		
        		int r1 = amenu.getHeight() + a.getHeight()/2;
        		int c1 = (int) (a.getWidth());
        		
        		a.setXPos(c1);
        		a.setYPos(r1);
        		a.id = 2;
        		a.res = res;
        		a.hastext = true;
        		a.mytext = "Get it";
        		a.textcolor = Color.WHITE;
        		a.textsize = gw(a.textsize);
        		a.textoffset = gw(17);
          		
        		mSprites.add(a);
        		
        		
        		
        		AnimatedSprite b = new AnimatedSprite();
        		b.Initialize(mchaseit, mchaseit.getHeight(), mchaseit.getWidth(),24, 1, true);
        		int r2 = (int)(a.getHeight()*1 + a.getXPos());
        		b.setXPos(c1);
        		b.setYPos(r2);//mchaseit.getHeight() / 2 + gh(200) + a.getHeight()  + gh(spacer));
        		b.id = 3;
        		b.res = res;
        		b.hastext = true;
        		b.mytext = "Chase it";
        		b.textcolor = Color.WHITE;
        		b.textsize = gw(b.textsize); 
        		b.textoffset = gw(17);
              		
        		mSprites.add(b);
        		
        		
        		

        		AnimatedSprite c = new AnimatedSprite();
        		c.Initialize(mdragit, mdragit.getHeight(), mdragit.getWidth(),24, 1, true);
        		c.setXPos(c1);
        		
        		int r3 = (int)(b.getHeight()*2.5 + b.getXPos());
        		c.setYPos(r3);//mdragit.getHeight() / 2 + gh(200) + a.getHeight() *2 + gh(spacer*2));
        		c.id = 4;
        		c.res = res;
        		c.hastext = true;
        		c.mytext = "Drag it";
        		c.textcolor = Color.WHITE;
        		c.textsize = gw(c.textsize); 
        		c.textoffset = gw(17);
              	
        		mSprites.add(c);
        		
        	
        		int c2 = (int)(a.getXPos()+ a.getWidth() + a.getWidth()*1.5);
        		
        		AnimatedSprite d = new AnimatedSprite();
        		d.Initialize(mmatchit, mmatchit.getHeight(), mmatchit.getWidth(),24, 1, true);
        		d.setXPos( c2);
        		d.setYPos(r1);//(mgetit.getHeight() / 2 + gh(100)));
        		//d.setYPos(mmatchit.getHeight() / 2 + gh(100) + a.getHeight() *3 + gh(spacer*3));
        		d.id = 5;
        		d.res = res;
        		d.hastext = true;
        		d.mytext = "Match it";
        		d.textcolor = Color.WHITE;
        		d.textsize = gw(d.textsize); 
        		d.textoffset = gw(17);
              	
        		mSprites.add(d);
        		
        		
        		AnimatedSprite e = new AnimatedSprite();
        		e.Initialize(mcountit, mcountit.getHeight(), mcountit.getWidth(),24, 1, true);
        		e.setXPos(c2);//mcountit.getWidth()/2+ gw(100));
        		e.setYPos(r2);// mchaseit.getHeight() / 2 + gh(200) + a.getHeight()  + gh(spacer));
        		//e.setYPos(mcountit.getHeight() / 2 + gh(100) + a.getHeight() *4 + gh(spacer*4));
        		e.id = 6;
        		e.res = res;
        		e.hastext = true;
        		e.mytext = "Count it";
        		e.textcolor = Color.WHITE;
        		e.textsize = gw(e.textsize); 
          		e.textoffset = gw(17);
              	
        		mSprites.add(e);
     
        		AnimatedSprite f = new AnimatedSprite();
        		f.Initialize(abcs,abcs.getHeight(), abcs.getWidth(),24, 1, true);
        		f.setXPos(c2);//abcs.getWidth()/2+ gw(100));
        		f.setYPos(r3);//mdragit.getHeight() / 2 + gh(200) + a.getHeight() *2 + gh(spacer*2));
        		f.id = 7;
        		f.res = res;
        		f.hastext = true;
        		f.mytext = "abcs";
        		f.textcolor = Color.WHITE;
        		f.textsize = gw(f.textsize); 
        		f.textoffset = gw(17);
              	
        		mSprites.add(f);
     
        		
        		
	}
        		setup = 1;
        		
        		
        		
        		
        	}
        	
        	
        	public void loadgame(int id){
        		
        		
        		//mSprites.clear();
        		
        		if(id == 2){cgame = 2; setup =2;}
        		if(id == 3) {
        			cgame = 3; 
        		
        		setup = 3;}
        		if(id == 4){cgame = 4; setup = 4;}
        		
        		if(id == 5){cgame = 5; setup = 5;}
        		
        		if(id == 6){cgame =6; setup = 6;}
        		if(id== 7){cgame = 7; setup = 7;}
        		
        	}
        	
            public void setupgetit(){
            	score = 0;
            	hiscore= 0;
            	
            	
        		for (int i = 0; i< maxdots; i++){
            		
    				addnew();
    		
    		
    		}
           
            	
            	
            }
            
            
            public void handlegetit(){
				
				int recount =0;
				
				synchronized(mSprites){
				for( AnimatedSprite a : mSprites){
					
					a.life= a.life-1;
					
				if(a.life < 1){
					
					if(a.mycolor == 1){
						score = score -2;
						
						
					}else{
						
						score = score +1;
						
					}
					recount = recount +1;
					
					a.dispose= true;
				}	
					
				
			
				}	
				}
					
				for(int ii = 0; ii < recount; ii++){
					
					
					
					addnew();
			
				}
				
				int done = 0;
				while(done == 0){
					done = 1;
					if(mSprites.size() < maxdots){
						addnew();
					done = 0;	
					}
					
					
				}
				
				
			}

			public void setupchaseit(){
				int x =gw(500);
				int y = gh(500);
				score = 0;
				hiscore= 0;
			
					
						aaa.maxlife = 150 - score;
						aaa.life = aaa.maxlife;
						aaa.sound = MediaPlayer.create(mContext, R.raw.sred1);
						aaa.mycolor =2;
						aaa.Initialize(ired, ired.getHeight(), ired.getWidth(),24, 1, true); 
					    aaa.setXPos((int)x);
					    aaa.setYPos((int)y);  
					   	synchronized(mSprites){
						mSprites.add(aaa);
					
						}
			}

			public void handlechaseit(){
				aaa.hastext = false;
					
				if(touchdown){
				float dd = (float)distance(tx, ty, aaa.getXPos() + aaa.getWidth()/2, aaa.getYPos() + aaa.getHeight()/2);
					if(dd < aaa.getWidth()/2){
						
						movedot = true;
					}else{
						movedot = false;
					}
					
				}
			
				if(movedot){
					
					aaa.animation = igreen;
					
					
					
				}else{
					aaa.animation = ired;
					
				}     		
				
				float velod = (float) .02;
				
				if(movedot){
					
					
					score = score + 1;
					if(score > hiscore){hiscore = score;}
					aaa.velo += velod;
					boolean rebound = false;
			
					if(aaa.getXPos() <  gw(30)) { 
					
						rebound = true;
					
					if(aaa.getYPos() < aaa.getHeight() * 2){
						
						aaa.rotation = (float) (Math.random() * (175 - 95) + 95);
			
					}
					
					else{
						
						aaa.rotation = (float) (Math.random() * (85-5) +5); 
						
						
						
					}
			
					}
					if(aaa.getXPos() >gw( 1000 )- aaa.getWidth() - gw(30) && rebound ==false) {
						
						
						
						if(aaa.getYPos() < aaa.getHeight() * 2){
			   				
			   				aaa.rotation = (float) (Math.random() * (265 -185) + 185);
			   						
			   				rebound = true;
						
			   				
			   			}
			   			
						else{
			   				
			   				aaa.rotation = (float) (Math.random() * (355 -275) + 275); 
			   				rebound = true;
			    			}
					
					
					}
			
					if(aaa.getYPos() <  gh(30) && rebound == false) {
						
						rebound = true;
						
					
						if(aaa.getXPos() < aaa.getWidth() * 2)
						{
							aaa.rotation = (float) (Math.random() * (175 - 95) + 95);
							
							
						}
					
						else
						{
							aaa.rotation = (float) (Math.random() * (265 - 185) + 185);
							
							
						}
					
					
					}
					
					if(aaa.getYPos() > gh(600) - aaa.getHeight() - gh(30) && rebound == false) {
					
					
						
						if(aaa.getXPos() < aaa.getWidth() * 2)
						{
							aaa.rotation = (float) (Math.random() * (85));
							
								rebound = true;
						}
					
						
						else	{
							aaa.rotation = (float) (Math.random() * (359 -275) + 275);
							rebound = true;
						
						}
					}
			
					if(rebound == true){
						
					
						if(aaa.rotation > 360){aaa.rotation -= 360;}
						if(aaa.rotation < 0){aaa.rotation += 360;}
					
					}
					
				
					int xxxx = (int) (aaa.getXPos() + aaa.getWidth()/2 + (aaa.velo * Math.sin(aaa.rotation * Math.PI/180)));
					int yyyy = (int) (aaa.getYPos() + aaa.getHeight() /2 -( aaa.velo * Math.cos(aaa.rotation*  Math.PI /180)));
					
			
					aaa.setXPos(xxxx);
					aaa.setYPos(yyyy);
			
					
					
				}else{
					aaa.velo -= velod;
					if(aaa.velo < 1){aaa.velo =1;}
					score = score -1;
					if(score < 1) { score = 0;}
					
				}
				
			
			}

			public void setupdragit(){
			            score = 0;
			            	hiscore= 0;
			            	level = 1;
			            	synchronized(mSprites){
			        			
			        			mSprites.clear();
			        			
			        			
			        		}
			            
			        	
			            	
			            	
			            	int col = 1;
			            	int npercol = 2;
			            	int curcol = 1;
			            	int spacer = gw(20);

			            	synchronized(lsprites)
			            	{			            	
			            lsprites.clear();
			            	
				
			            	for(int zz = 1; zz < 5; zz++)
			            	{	
			            	
			        	    
			            		AnimatedSprite dz = new AnimatedSprite();
			            	if(zz == 1){
			               		dz.Initialize(blevelgreen, blevelgreen.getHeight(), blevelgreen.getWidth(), 33, 1, true);
			                    
			            	}else
			            	{
			               		dz.Initialize(blevelred, blevelred.getHeight(),blevelred.getWidth(), 33, 1, true);
			                       	
			            	}
			            
			            	
			            	if(zz %2 == 1){ dz.setXPos( dz.getWidth()/2); }
		            		else{ dz.setXPos( dz.getWidth()/2 + spacer + dz.getWidth()); }
		            		
		            		
		            		dz.setYPos( amenu.getHeight() + spacer * col + col * dz.getHeight());
		            		curcol = curcol +1;
		            		if(curcol > npercol ){col = col + 1; curcol = 1;}
		            		
			            		dz.id = zz;
			            		dz.mytext = Integer.toString(zz);
			            		dz.hastext= true;
			            		dz.textsize = gw(dz.textsize); 
			            		dz.ffont = myfont; 
			            		dz.textcolor = Color.WHITE;
			            		dz.textoffset = gw(17);
			              		
			            	
			            		lsprites.add(dz);
			            	
			            		
			            	}
			            	
			            	}
			            	
			           
			            	
			        
			            	
			          	  if(level == 1){
			        		  
			        		  for (int i = 1; i < 6; i++) {
			        				
			        				  AnimatedSprite dott = new AnimatedSprite();
			        			
			        				  dott.textsize = gw(dott.textsize); 
			        				dott.textoffset = gw(17);
			                  		
			        				dott.mytext = Integer.toString(i);
			        				dott.hastext = true;
			        				dott.ffont = myfont;
			        				dott.id = i;
			        				
			        				dott.Initialize(outline, outline.getHeight(), outline.getWidth(),24, 1, true);
			        				dott.setXPos((int) (tw - outline.getWidth() * 2));
			                		dott.setYPos(gh(10)* (i-1) + (i-1) * dott.getHeight() + dott.getHeight() /2);
			          
			                		synchronized(mSprites){
			                		mSprites.add(dott);
			                		}
			                	}
			        			
			        	
			        		}
			            	
			  			
			          	  			aaa.textsize = gw(50); 
			          	  			aaa.textoffset = gw(17);
			      		   			aaa.mytext = "1";
			            			aaa.id = 1;
			            			aaa.hastext = true;
			            			aaa.ffont = myfont;
			            			aaa.maxlife = 150 - score;
			            			aaa.life = aaa.maxlife;
			            			aaa.mycolor =2;
			            			aaa.Initialize(ired100, ired100.getHeight(), ired100.getWidth(),24, 1, true); 
			            		    aaa.setXPos((int) ((tw - ired100.getWidth()/2)/2));
			            		    aaa.setYPos((int) ((th - ired100.getHeight()/2)/2));  
			            		    //playnumber(aaa.id);
			            		   	
			            		   	synchronized(mSprites){
			            			mSprites.add(aaa);
			            		
			            			}
			            	
			            	
			            }

			public void loadlevel2dragit(){
				int col = 1;
            	int npercol = 2;
            	int curcol = 1;
            	int spacer = gw(20);
            
				level = 2;
				
				synchronized(mSprites){
					
					mSprites.clear();
					
					
				}
				

		            	synchronized(lsprites)
		            	{			            	
		            lsprites.clear();
		            	
			
				
				for(int zz = 1; zz < 5; zz++)
				{
					
					AnimatedSprite dz = new AnimatedSprite();
				if(zz == 2){
			   		dz.Initialize(blevelgreen, blevelgreen.getHeight(), blevelgreen.getWidth(), 33, 1, true);
			        
				}else
				{
			   		dz.Initialize(blevelred, blevelred.getHeight(),blevelred.getWidth(), 33, 1, true);
			           	
				}
				if(zz %2 == 1){ dz.setXPos( dz.getWidth()/2); }
        		else{ dz.setXPos( dz.getWidth()/2 + spacer + dz.getWidth()); }
        		
        		
        		dz.setYPos( amenu.getHeight() + spacer * col + col * dz.getHeight());
        		curcol = curcol +1;
        		if(curcol > npercol ){col = col + 1; curcol = 1;}
       
        		
        		dz.textsize = gw(dz.textsize); 
					dz.textoffset = gw(17);
					dz.id = zz;
					dz.hastext= true;
					dz.ffont = myfont;
					dz.mytext = Integer.toString(zz);
					dz.textcolor = Color.WHITE;
					
					lsprites.add(dz);
					//mSprites.add(dz);
				}
				
		            	}
				
				
				
				
			//	  int mxpos = blevelgreen.getWidth()*2 + blevelgreen.getWidth()/2 + spacer*2;
			  for (int i = 1; i < 6; i++) {
			
				  AnimatedSprite dott = new AnimatedSprite();
				dott.textsize = gw(dott.textsize); 
				
					dott.mytext = Integer.toString(i);
					dott.hastext = true;
					dott.id = i;
					dott.ffont = myfont;
					dott.textoffset = gw(17);
					dott.Initialize(outline, outline.getHeight(), outline.getWidth(),24, 1, true);
			  		dott.setXPos(levelbuttonsoffset);
			  		dott.setYPos(gh(10)* (i-1) + (i-1) * dott.getHeight() + dott.getHeight() /2);
			  	
			  		mSprites.add(dott);
			  		}
			
				
				
				
				
				  
				  for (int i = 6; i < 11; i++) {
			
					  AnimatedSprite dott = new AnimatedSprite();
					  dott.textsize = gw(dott.textsize); 
						dott.textoffset = gw(17);
						dott.mytext = Integer.toString(i);
						dott.hastext = true;
						dott.id = i;
						dott.ffont = myfont;
						dott.Initialize(outline, outline.getHeight(), outline.getWidth(),24, 1, true);
        				dott.setXPos((int) (tw - outline.getWidth() * 2));
			    		dott.setYPos(gh(10)* (i-6) + (i-6) * dott.getHeight() + dott.getHeight() /2);
			    	
			    		mSprites.add(dott);
			    		}
				  			aaa.textsize = gw(50); 
							aaa.textoffset = gw(17);
			    			aaa.mytext = "1";
			    			aaa.ffont = myfont;
			    			aaa.id = 1;
			    			aaa.hastext = true;
			    			aaa.maxlife = 150 - score;
			    			aaa.life = aaa.maxlife;
			    			aaa.mycolor =2;
			    			aaa.Initialize(ired100, ired100.getHeight(), ired100.getWidth(),24, 1, true); 
			    			   aaa.setXPos((int) ((tw - ired100.getWidth()/2)/2));
		            		    aaa.setYPos((int) ((th - ired100.getHeight()/2)/2));  
		            		 		     	synchronized(mSprites){
			    			mSprites.add(aaa);
			    		
			    			}
			}

			public void loadlevel3dragit(){
        		level = 3;
        		int col = 1;
            	int npercol = 2;
            	int curcol = 1;
            	int spacer = gw(20);
            
        		
	synchronized(mSprites){
        			
        			mSprites.clear();
        			
        			
        		}
        		
 	
	synchronized(lsprites)
	{			            	
lsprites.clear();
		
	for(int zz = 1; zz < 5; zz++)
	{
		
		AnimatedSprite dz = new AnimatedSprite();
	if(zz == 3){
   		dz.Initialize(blevelgreen,blevelgreen.getHeight(),blevelgreen.getWidth(), 33, 1, true);
        
	}else
	{
   		dz.Initialize(blevelred, blevelred.getHeight(), blevelred.getWidth(), 33, 1, true);
           	
	}
	if(zz %2 == 1){ dz.setXPos( dz.getWidth()/2); }
	else{ dz.setXPos( dz.getWidth()/2 + spacer + dz.getWidth()); }
	
	
	dz.setYPos( amenu.getHeight() + spacer * col + col * dz.getHeight());
	curcol = curcol +1;
	if(curcol > npercol ){col = col + 1; curcol = 1;}

	
	
	dz.textsize = gw(dz.textsize); 
		dz.textoffset = gw(17);
		dz.id = zz;
		dz.hastext= true;
		dz.ffont = myfont;
		dz.mytext = Integer.toString(zz);
		dz.textcolor = Color.WHITE;
		
		lsprites.add(dz);
	}
	}

        		aaa.id = 1;
        		float ang = 0;
        		float anginc= 360/12;
        		ang = ang + anginc;
        		
        		for(int i = 1; i < 13; i++){
        			  
        			
        			
        			
        			  AnimatedSprite dott = new AnimatedSprite();
        				dott.textoffset = gw(17);
        				dott.mytext = Integer.toString(i);
        				dott.hastext = true;
        				dott.id = i;
        				dott.ffont = myfont;
        				dott.textsize = gw(dott.textsize); 
                		
        				dott.Initialize(outline, outline.getHeight(), outline.getWidth(),24, 1, true);
                		dott.setXPos((int) ((tw - ired100.getWidth()/2)/2 + gw(270) * Math.sin(ang * Math.PI /180)));
                		dott.setYPos((int) ((th - ired100.getWidth()/2)/2 - gw(270) * Math.cos(ang * Math.PI / 180)));
                	
                		mSprites.add(dott);
          	ang = ang + anginc;
          	
        		}
        
        			
            		
        		aaa.textsize = gw(50); 
        		aaa.textoffset = gw(17);
            			aaa.mytext = "1";
            			aaa.id = 1;
            			aaa.hastext = true;
            			aaa.maxlife = 150 - score;
            			aaa.life = aaa.maxlife;
            			aaa.ffont = myfont;
            			aaa.mycolor =2;
            			aaa.Initialize(ired100, ired100.getHeight(), ired100.getWidth(),24, 1, true); 
            			   aaa.setXPos((int) ((tw - ired100.getWidth()/2)/2));
	            		    aaa.setYPos((int) ((th - ired100.getHeight()/2)/2));  
	            			//playnumber(aaa.id);
            		   	    		 
                		   	synchronized(mSprites){
            			mSprites.add(aaa);
            		
            			}
        	
        	
        	
        	}
        	
        	
        	
        	public void loadlevel4dragit(){
        		int col = 1;
            	int npercol = 2;
            	int curcol = 1;
            	int spacer = gw(20);
            
        		level = 4;
        		
        		synchronized(mSprites){
        			
        			mSprites.clear();
        			
        			
        		}
            
        	 	
            	synchronized(lsprites)
            	{			            	
            lsprites.clear();

            	
            	for(int zz = 1; zz < 5; zz++)
            	{
            		
            		AnimatedSprite dz = new AnimatedSprite();
            	if(zz == 4){
               		dz.Initialize(blevelgreen, blevelgreen.getHeight(), blevelgreen.getWidth(), 33, 1, true);
                    
            	}else
            	{
               		dz.Initialize(blevelred, blevelred.getHeight(), blevelred.getHeight(), 33, 1, true);
                       	
            	}
            	if(zz %2 == 1){ dz.setXPos( dz.getWidth()/2); }
        		else{ dz.setXPos( dz.getWidth()/2 + spacer + dz.getWidth()); }
        		
        		
        		dz.setYPos( amenu.getHeight() + spacer * col + col * dz.getHeight());
        		curcol = curcol +1;
        		if(curcol > npercol ){col = col + 1; curcol = 1;}
       
        		
        		dz.textsize = gw(dz.textsize); 
            		dz.textoffset = gw(17);
            		dz.id = zz;
            		dz.hastext= true;
            		dz.ffont = myfont;
            		dz.mytext = Integer.toString(zz);
            		dz.textcolor = Color.WHITE;
            		
            		lsprites.add(dz);
            	}
            	
            
            	}	
            	
            	col = 1;
            	npercol = 2;
            	curcol = 1;
            	spacer = gw(20);
            	int row = 1;
            	int nperrow = 5;
            	int currow = 1;
            	int io = outline.getWidth() * 6 + spacer * 6;
            	  
      		  for (int i = 1; i < 21; i++) {
        
      			  AnimatedSprite dott = new AnimatedSprite();
      			dott.textsize = gw(dott.textsize); 
        		
      				dott.mytext = Integer.toString(i);
      				dott.hastext = true;
      				dott.id = i;
      				dott.ffont = myfont;
      				dott.textoffset = gw(17);
      				dott.Initialize(outline, outline.getHeight(), outline.getWidth(),24, 1, true);
              		dott.setXPos((int) ((tw - io) + outline.getWidth() *  currow + spacer * currow));	
              		dott.setYPos((col-1) * outline.getHeight() + outline.getHeight()/2 + (col-1)* spacer); //10* (i-1) + (i-1) * dott.getHeight() + dott.getHeight() /2);
              	currow++;
              	if(currow > nperrow){currow = 1; col = col + 1;}
              		
              		mSprites.add(dott);
              		}
      		
            	        			
        		  			aaa.ffont = myfont;
        		  			aaa.textsize = gw(50); 
            				aaa.textoffset = gw(17);
        		  			aaa.mytext = "1";
                			aaa.id = 1;
                			aaa.hastext = true;
                			aaa.maxlife = 150 - score;
                			aaa.life = aaa.maxlife;
                			aaa.mycolor =2;
                			aaa.Initialize(ired100, ired100.getHeight(), ired100.getWidth(),24, 1, true); 
                			aaa.setXPos (blevelgreen.getWidth()*2 + spacer*3 + blevelgreen.getWidth()/2);
                    		aaa.setYPos((int) ((th- aaa.getHeight()/2)/2));
                    	
                		   	
                		   	synchronized(mSprites){
                			mSprites.add(aaa);
                		
                			}
        	
        		
        		
        		
        		
        		
        		
        		
        		
        		
        	}
        	
        	
        	public void handledragit(){
				int spacer = gw(20);
				synchronized(mSprites){
			   		for( AnimatedSprite a : mSprites){
			  
			   			if(a.id == aaa.id && a != aaa){
			   				
			   				
			   			float dd =(float) distance(a.getXPos(), a.getYPos(), aaa.getXPos(), aaa.getYPos());
			   			
			   			if(dd < a.getWidth()/2)
			   			{
			   				
			   				playcorrect();
			   				
			   			if(level == 1){
			   				if(a.id != 5){
			   				
			   					a.animation = smile;
			   					
			   				    aaa.setXPos((int) ((tw - ired100.getWidth()/2)/2));
		            		    aaa.setYPos((int) ((th - ired100.getHeight()/2)/2));  
		            		  	aaa.id++;
			   					aaa.mytext = Integer.toString(aaa.id);
			   					
			   					
			   					
			   					
			   					
			   				}else{
			   					loadlevel2dragit();
							}
			   				
			   			}
			   			else{
			   				if(level == 2){
			   					
			   					if(a.id != 10){
			           				
			       					a.animation = smile;
			       					
			       				    aaa.setXPos((int) ((tw - ired100.getWidth()/2)/2));
			            		    aaa.setYPos((int) ((th - ired100.getHeight()/2)/2));  
			            			aaa.id++;
			       					aaa.mytext = Integer.toString(aaa.id);
			       					
			       					
			       					
			       					
			       				}else{
			       				loadlevel3dragit();
			   					}
			   					
			   					
			   				}
			   				else{
			   					
			   					if(level == 3){
			       					
			       					if(a.id != 12){
			               				
			           					a.animation = smile;
			           				
			           				   aaa.setXPos((int) ((tw - ired100.getWidth()/2)/2));
				            		    aaa.setYPos((int) ((th - ired100.getHeight()/2)/2));  
				            				aaa.id++;
			           					aaa.mytext = Integer.toString(aaa.id);
			           					
			           					
			           					
			           					
			           				}else{
			           				loadlevel4dragit();
			       					}
			       					
			       					
			       				}
			   					
			   						else{
			   					
			   					
			   					if(level == 4){
			       					
			       					if(a.id != 20){
			               				
			           					a.animation = smile;
			           					aaa.setXPos (blevelgreen.getWidth()*2 + spacer*3 + blevelgreen.getWidth()/2);
			                    		aaa.setYPos((int) ((th- aaa.getHeight()/2)/2));
			                    	 				aaa.id++;
			           					aaa.mytext = Integer.toString(aaa.id);
			           					
			           					
			           					
			           					
			           				}else{
			           				setupdragit();
			       					}
			       					
			       					
			       				}
			   					
			   				}	
			   				}
			   				
			   		
			   				
			   				
			   				
			   			}
			   				
			   				
			   				
			   				
			   				
			   				
			   				
			   			}
			   				
			   				
			   				
			   			}
			   			
			   			
			   			
			   			
			   		}
			   		}
				
				
				
				
				
				
				
				
				
				
				
				
				
			}

			public void setupmatchit(){
				
				
				
				
				makematchitquestion();
				
				
				
			}

			public void makematchitquestion(){
				synchronized(mSprites){
					
					mSprites.clear();
					
					
				}
				
				
			
				int maxtypeobj = 9;
				otype  = (int) Math.ceil(Math.random() * maxtypeobj);
				otratype = otype;
				while(otype == otratype) {
					otratype = (int) Math.ceil(Math.random() * maxtypeobj);
					}
				
				
				int otraplaced = 0;
					int slot1 = 0;
					int slot2 = 0;
				int slot3 = 0; 
					
					if (Math.random() < .5) { slot1 = otype; } 
					else {
							
						 slot1 = otratype;
						otraplaced = 1;
							
							
							}
					
					if (otraplaced == 1) {
						
						 slot2 = otype;
						
						}else {
							
							
							if (Math.random() < .5) {  slot2 = otype; }
							else {
								slot2 = otratype;
								otraplaced = 1;
								
								}
							
							}
					if (otraplaced == 1) { slot3 = otype; }
			else{ slot3 = otratype; }
			
//asdfasdf
			  int myy = topmenuoffset + spacer*3;
					
					
					AnimatedSprite ob1 = new AnimatedSprite();
					
					 ob1.Initialize(getotype(slot1), getotype(slot1).getHeight(), getotype(slot1).getWidth(),24, 1, true); 
			 		ob1.setXPos((int) (levelbuttonsoffset));
			 		ob1.setYPos(myy);  
					ob1.id = slot1;
					
					mSprites.add(ob1);
			
					
					AnimatedSprite ob2 = new AnimatedSprite();
					
					 ob2.Initialize(getotype(slot2), getotype(slot2).getHeight(), getotype(slot2).getWidth(),24, 1, true); 
			 		ob2.setXPos((int)(ob1.getXPos()+ ob1.getWidth()*2.5));
			 		ob2.setYPos(myy);  
					ob2.id = slot2;
					
					mSprites.add(ob2);
			
					
			
			AnimatedSprite ob3 = new AnimatedSprite();
			
			 ob3.Initialize(getotype(slot3), getotype(slot3).getHeight(), getotype(slot3).getWidth(),24, 1, true); 
			ob3.setXPos((int)(ob2.getXPos() + ob2.getWidth()*2.5));
			ob3.setYPos(myy);  
			ob3.id = slot3;
			
			mSprites.add(ob3);
				
				AnimatedSprite mytext = new AnimatedSprite();
				mytext.Initialize(blank, 0, 0, 24, 1, true);
				mytext.hastext = true;
				mytext.textcolor = Color.WHITE;
				mytext.mytext = "Which object does not belong?";
				mytext.setXPos(gw(700));
				mytext.setYPos(gh(500));
				mytext.ffont = myfont;
				mSprites.add(mytext);
			}

			public void setupcountit(){
				if(intro == null){intro = MediaPlayer.create(mContext, R.raw.intro); }
				intro.start();
				loadcountitlevel(1);
				
				
				
				
				
				
				
				
				
				
				
			}

			public void loadcountitlevel(int lev){
			score = 0;
			hiscore = 0;
			synchronized(mSprites){
				
				mSprites.clear();
				
				
			}
				if(lev == 1){
					currentnumber =1;
				
					
					for(int i = 1; i < 10; i++){
						
						 AnimatedSprite dott = new AnimatedSprite();
						dott.textoffset = gw(17);
						dott.textsize = gw(dott.textsize);
						dott.mytext = Integer.toString(i);
						dott.hastext = true;
						dott.id = i;
						dott.ffont = myfont;
						
						dott.Initialize(iconbg, iconbg.getHeight(), iconbg.getWidth(),24, 1, true);
			     		
						int bor = gw(10);
						dott.setXPos(amenuoffset + bor + iconbg.getWidth()* i + bor*i);
			     		dott.setYPos(bor + iconbg.getHeight()/2);
			     		mSprites.add(dott);
			 		}
					
				
					 numobj = 0;
					numobj= (int) Math.ceil(Math.random() * 9);
					
					
					int counter = 1;
					int done = 1;
					int x = 0;
					int y = 0;
					
					while (done== 1 && counter <= numobj){
						
							synchronized(mSprites){
							
						x = (int) (Math.random() * (tw - 2*apple.getWidth())) + apple.getWidth();
						y = (int) (Math.random() * (th - 2*apple.getHeight() - iconbg.getHeight() ) + apple.getHeight() + iconbg.getHeight());
						int flag = 0;
					
						
					
							
							
							for( AnimatedSprite b : mSprites){			
							float dd =(float) distance(x,y, b.getXPos(), b.getYPos());
							if(dd < apple.getWidth() * 2) {flag = 1;}            //if(b.recthit(x - apple.getWidth()/2, y - apple.getHeight()/2) ){ flag  =1; }
							}
				
						
						
						
				if(flag == 0){
					AnimatedSprite zz = new AnimatedSprite();
					zz.id = counter + 200;
					zz.Initialize(apple, apple.getHeight(), apple.getWidth(),24, 1, true);
			        	
				
						zz.setXPos(x);
						zz.setYPos(y);
						mSprites.add(zz);
						
						counter++;
							
				}
							
					
							
						}		
						
						
						
					}
				
				
					
					
					
					
					}
					
					
					
					
					
					
					
				}

			public void setupabcs(){
			        		
			        		
			        	
			        		synchronized(mSprites){
			        			
			        		mSprites.clear();
			        			
			        			
			        	}
			        		
			        		if(blevelred == null){blevelred = BitmapFactory.decodeStream(res.openRawResource(R.drawable.blevelred)); 
			    			blevelred = Bitmap.createScaledBitmap(blevelred, gw(blevelred.getWidth()), gh(blevelred.getHeight()), false);
			    			}
			    			if(blevelgreen == null){blevelgreen = BitmapFactory.decodeStream(res.openRawResource(R.drawable.blevelgreen)); 
			    			
			    			blevelgreen = Bitmap.createScaledBitmap(blevelgreen, gw(blevelgreen.getWidth()), gh(blevelgreen.getHeight()), false);
			    			}
			        			
			        			
			        	  if(lsprites.size() < maxabcgames){
			        		  
			        		  
			        		  
			        		 	
				            	int col = 1;
				            	int npercol = 2;
				            	int curcol = 1;
				            	int spacer = gw(20);

				            	synchronized(lsprites)
				            	{			            	
				            lsprites.clear();
				            	
					
				            	for(int zz = 1; zz < 7; zz++)
				            	{	
				            	
				        	    
				            		AnimatedSprite dz = new AnimatedSprite();
				            	if(zz == level){
				               		dz.Initialize(blevelgreen, blevelgreen.getHeight(), blevelgreen.getWidth(), 33, 1, true);
				                    
				            	}else
				            	{
				               		dz.Initialize(blevelred, blevelred.getHeight(),blevelred.getWidth(), 33, 1, true);
				                       	
				            	}
				            
				            	
				            	if(zz %2 == 1){ dz.setXPos( dz.getWidth()/2); }
			            		else{ dz.setXPos( dz.getWidth()/2 + spacer + dz.getWidth()); }
			            		
			            		
			            		dz.setYPos( amenu.getHeight() + spacer * col + col * dz.getHeight());
			            		curcol = curcol +1;
			            		if(curcol > npercol ){col = col + 1; curcol = 1;}
			            		
				            		dz.id = zz;
				            		dz.mytext = Integer.toString(zz);
				            		dz.hastext= true;
				            		dz.textsize = gw(dz.textsize); 
				            		dz.ffont = myfont; 
				            		dz.textcolor = Color.WHITE;
				            		dz.textoffset = gw(17);
				              		
				            	
				            		lsprites.add(dz);
				            	
				            		
				            	}
				            	
				            	}
				            	
				     
			        		  
			        		  
			        		  /*
			        		synchronized(lsprites){
			        	  	lsprites.clear();
			        	  
			        	
			        			for(int zz = 1; zz <= maxabcgames; zz++)
			            	{
			            		
			            		AnimatedSprite dz = new AnimatedSprite();
			            	if(zz == level){
			               		dz.Initialize(blevelgreen, blevelgreen.getHeight(), blevelgreen.getWidth(), 33, 1, true);
			                    
			            	}else
			            	{
			               		dz.Initialize(blevelred,blevelred.getHeight(), blevelred.getHeight(), 33, 1, true);
			                       	
			            	}
			            		dz.setXPos(gw(10) + dz.getWidth());
			            		dz.setYPos( gw(80)+ gw(10) * zz + zz * dz.getHeight());
			            		
			            		dz.id = zz;
			            		dz.hastext= true;
			            		dz.res = res;
			            		dz.mytext = Integer.toString(zz);
			            		dz.textcolor = Color.WHITE;
			            		
			            		lsprites.add(dz);
			            	
			            	}
			        		
			        		}
*/
				            	}
			        	   		
			        	   		
			        	   		
			        	   		
			        	   		
			        	   		
			        	   		
			        	   		
			        	   		
			        	   		
			        	   		
			        		
			        	   		
			        	   		if(abccorrect == 0 || abccorrect == 26){
			        	   		
			        	   		synchronized(abcmenu){abcmenu.clear();}
			        	   		
			        	   		
			        	   		abccorrect =0;	
			        	   		
			        	   		
			        	   		
			        	   		
			        	   		int border = gw(1);
			        	   		int toprow = gw(26);
			        	   	
			        	   		for(int ss = 1; ss <=26; ss++){
			        	   		
			        	   		AnimatedSprite f = new AnimatedSprite();
			        	   		
			        	   		f.Initialize(blevelred, blevelred.getWidth(), blevelred.getHeight(), 33, 1, true);
			        	   		
			        	   		if(ss < 14){
			        	   		f.setXPos( amenuoffset + (ss-1) * blevelred.getWidth() + (ss-1) * border);
			        	   		f.setYPos(blevelred.getHeight()/2);	
			        	   		}
			        	   		if(ss > 13){
			        	   			f.setXPos(amenuoffset + (ss-14) * blevelred.getWidth() + (ss-14) * border  );
			            	   		f.setYPos(blevelred.getHeight()/2 + border + blevelred.getHeight());	
			            	   			
			        	   			
			        	   			
			        	   		}
			        	   		f.mycolor = 2;
			        	   		f.id = ss;
			        	   		f.hastext = true;
			        	   		f.textcolor = Color.WHITE;
			        	   		f.ffont = myfont;
			        	   		f.textsize = gw(70);
			        	   		
			        	   		if( level  == 1 || level == 4) {f.mytext = getlower(ss);}
			        	   		else{if( level  == 2 || level == 5) {f.mytext = getupper(ss);}
			        	   		else{if( level  == 3 || level == 6) {f.mytext = getlower(ss) + getupper(ss); f.textsize = gw(52);}
			        	   		}}
			        	   		 
			        	   		
			        	   		
			        	   		
			        	   		synchronized(abcmenu){
			        	   		abcmenu.add(f);
			        	   		}
			        	   		
			        	   		}
			        	   	}
			        	   		
			        	   		
			        	   		
			        	   		
			        	   		
			        	   		
			        	   		choices.clear();
			        	   		
			        	   		
			        	   		
			        	   	 AnimatedSprite sans = new AnimatedSprite();
			           	   		
			        		int pass = 0;
			        		while(pass == 0){
			        	   		
			        	   ans = (int) Math.ceil(Math.random()*26);
			        		   
			        	   
			        	   synchronized(abcmenu){
			        	   for(AnimatedSprite abc: abcmenu){
			        		   
			        		
			        		   
			        		   if(abc.mycolor == 2 && abc.id == ans){
			        			   
			        			   pass = 1;
			        			   
			        			   
			        		   }
			        		   
			        	   }
			        	   
			        	   
			        	   
			        		}
			        		}
			    
			        		
			        		synchronized(words){
			        	 AnimatedSprite zzz = new AnimatedSprite();
			        	 zzz.word = "find";
			        	 zzz.setdelay(10);
			        	 words.add(zzz);
			        	 
			        	 
			        	   AnimatedSprite ttt = new AnimatedSprite();
			        	   ttt.word = getlower(ans);
			        	   ttt.setdelay(10);
			        	  words.add(ttt);
			        		}
			        	  
			        		sans.id = ans;
			        		choices.add(sans);
			        	   	
			        	   
			        	   	
			        		  AnimatedSprite label = new AnimatedSprite();
			           	   
			           	   label.Initialize(blank, 0, 0, 33, 1, true);
			           	   label.textsize = gw(140);
			           	   label.setXPos((int) (tw/2 ));
			           	   label.setYPos(topmenuoffset + 3*spacer);
			           	   label.hastext = true;
			           	   label.textcolor = Color.WHITE;
			           	   label.ffont = myfont;
			           	   switch(level){
			           	   
			           	   case 1:
			           		   label.mytext = "find " + getlower(ans);
			           		   break;
			           	   case 2:
			           		   label.mytext = "FIND " + getupper(ans);
			           		   break;
			           	   case 3:
			           		   label.mytext = "Find " + getlower(ans);
			           		   break;
			           	  case 4:
			          		   label.mytext = "find " + getlower(ans);
			          		   break;
			          	   case 5:
			          		   label.mytext = "FIND " + getupper(ans);
			          		   break;
			          	   case 6:
			          		   label.mytext = "Find " + getlower(ans);
			          		   break;
			          	   }
			           	   
			           	   mSprites.add(label);
			           	
			        	
			           	   int shownum = 0;
			           	   if(level == 1 || level == 2 || level == 3){
			           		   shownum = 2;
			           		   
			           	   }else{shownum = 5;}
			           	   
			        			
			        		
			        				
			        				if(shownum==2){
			        				AnimatedSprite a2 = new AnimatedSprite();
			        				choices.add(a2);
			        				
			        				}
			        				if(shownum == 5){
			        				AnimatedSprite a2 = new AnimatedSprite();
				        			AnimatedSprite a3 = new AnimatedSprite();
			        				AnimatedSprite a4 = new AnimatedSprite();
			        				AnimatedSprite a5 = new AnimatedSprite();
			        				choices.add(a2);
				        			choices.add(a3);
			        				choices.add(a4);
			        				choices.add(a5);
			        				}
			        				
			        				for(AnimatedSprite gg: choices){
			        					//if not first one.
			        					if(gg.id != ans){
			        						
			        					int idd = (int) Math.ceil(Math.random()*26);
			        					boolean pass3 = false;
			            				while(pass3 == false){
			        					for (AnimatedSprite jj: choices){
			            					pass3 = true;
			            					if(jj.id == idd){
			            						pass3 = false;
			            						idd = (int) Math.ceil(Math.random()*26);
			                				}
			            				
			        					}	}
			        					
			            				
			            				gg.id = idd;
			        					}
			        					
			        				}
			        				
			        				for(AnimatedSprite az: choices){
			        				
			        				AnimatedSprite ts = new AnimatedSprite();
			        				
			        				
			        				ts.place = (int) Math.ceil(Math.random()*shownum);
			        				
			        				
			        				boolean pass2 = false;
			        				while(pass2 == false){
			        					pass2 = true;
			        					for(AnimatedSprite zz: choices){
			        						
			        						if(zz.place == ts.place){
			        							pass2 = false;
			        							ts.place = (int) Math.ceil(Math.random()*shownum);
			        							
			        						}
			        						
			        						
			        					}
			        						
			        						
			        				}
			        				az.place = ts.place;
			        				
			        			}
			        			
			        			
			        				
			        				
			        				
			        				
			        				
			        				
			        			for(AnimatedSprite ff: choices){
			        				
			        				switch(level){
			        				case 1:
			        					ff.mytext = getlower(ff.id);
			        				break;
			        				case 2:
			        					ff.mytext = getupper(ff.id);
				            			break;
			        				case 3:
			            				ff.mytext = getupper(ff.id);
				            			break;
				        			case 4:
			            				ff.mytext = getlower(ff.id);
						           	break;
			            			case 5:
			            				ff.mytext = getupper(ff.id);
			            			break;
			            			case 6:
			            				ff.mytext = getupper(ff.id);
			            			break;
			        				}
			        				
			        				
			        				ff.hastext = true;	
			        				
			        				if(shownum == 5){
			        					ff.Initialize(bgreds, bgreds.getHeight(), bgreds.getWidth(),24, 1, true);
					        				}else{if(shownum == 2){
					        					ff.Initialize(bgred, bgred.getHeight(), bgred.getWidth(),24, 1, true);
							        			
			        				}
			        				}
			        				
			        				
			        				ff.setXPos(((int)(levelbuttonsoffset + ff.getWidth()/2+(ff.place-1)*(tw-levelbuttonsoffset)/shownum)));// - ff.getWidth()*shownum)/2  + (ff.place)* ff.getWidth());//lb.getWidth() /2);
			                		ff.setYPos(label.getYPos() + label.textsize *2);//450);
			                		ff.textsize = gw(160);
			                		ff.textoffset = gw(20);
			                		ff.textcolor = Color.WHITE;
			        				ff.ffont = myfont;
			        				
			        				mSprites.add(ff);
			        			}
			            	}

			public void playcorrect(){
        		
        		
        		int flag = (int) Math.ceil(Math.random() * 6);
        		
        		if(flag == 1){
        			 AnimatedSprite zzz = new AnimatedSprite();
                	 zzz.word = "secorrect";
                	 zzz.setdelay(10);
                	 words.add(zzz);
        			
        		//	   if(scorrect == null){scorrect = MediaPlayer.create(mContext, R.raw.scorrect);}
        		//	   scorrect.start();
        		}
        		if(flag == 2){
        			 AnimatedSprite zzz = new AnimatedSprite();
                	 zzz.word = "seclapping";
                	 zzz.setdelay(10);
                	 words.add(zzz);
        			//if(clapping == null){clapping = MediaPlayer.create(mContext, R.raw.clapping);}
        			//clapping.start();
        		}
        		if(flag == 3){
        			 AnimatedSprite zzz = new AnimatedSprite();
                	 zzz.word = "seexcellent";
                	 zzz.setdelay(10);
                	 words.add(zzz);
        			
        			//if(excellent == null){excellent = MediaPlayer.create(mContext, R.raw.excellent);}
        			//excellent.start();
        		}
        		if(flag == 4){
        			 AnimatedSprite zzz = new AnimatedSprite();
                	 zzz.word = "segoodjob";
                	 zzz.setdelay(10);
                	 words.add(zzz);
        			
        			//if(goodjob == null){goodjob = MediaPlayer.create(mContext, R.raw.goodjob);}
        		//	goodjob.start();
        		}
        		if(flag == 5){
        			 AnimatedSprite zzz = new AnimatedSprite();
                	 zzz.word = "senicework";
                	 zzz.setdelay(10);
                	 words.add(zzz);
        			
        			//if(nicework == null){nicework = MediaPlayer.create(mContext, R.raw.nicework);}
        			//nicework.start();
        		}
        		if(flag == 6){
        			 AnimatedSprite zzz = new AnimatedSprite();
                	 zzz.word = "sethatsright";
                	 zzz.setdelay(10);
                	 words.add(zzz);
        			//if(thatsright == null){thatsright = MediaPlayer.create(mContext, R.raw.thatsright);}
        			//thatsright.start();
        		}
        		
        		
        		
        		
        		
        		
        	}
        	
        	
        	
        	public void playoops(){
        		 AnimatedSprite zzz = new AnimatedSprite();
            	 zzz.word = "seoops";
            	 zzz.setdelay(10);
            	 words.add(zzz);
    		
        		
        		
        		
        	}
        	public void playnumber(int i){
        		if(a1 == null){a1 = MediaPlayer.create(mContext, R.raw.a1); }
        		if(a2 == null){a2 = MediaPlayer.create(mContext, R.raw.a2); }
        		if(a3== null){a3 = MediaPlayer.create(mContext, R.raw.a3); }
        		if(a4 == null){a4 = MediaPlayer.create(mContext, R.raw.a4); }
        		if(a5 == null){a5 = MediaPlayer.create(mContext, R.raw.a5); }
        		if(a6 == null){a6 = MediaPlayer.create(mContext, R.raw.a6); }
        		if(a7 == null){a7 = MediaPlayer.create(mContext, R.raw.a7); }
        		if(a8 == null){a8 = MediaPlayer.create(mContext, R.raw.a8); }
        		if(a9 == null){a9 = MediaPlayer.create(mContext, R.raw.a9); }
        		if(a10 == null){a10 = MediaPlayer.create(mContext, R.raw.a10); }
        		if(a11 == null){a11 = MediaPlayer.create(mContext, R.raw.a11); }
        		if(a12 == null){a12 = MediaPlayer.create(mContext, R.raw.a12); }
        		if(a13 == null){a13 = MediaPlayer.create(mContext, R.raw.a13); }
        		if(a14 == null){a14 = MediaPlayer.create(mContext, R.raw.a14); }
        		if(a15 == null){a15 = MediaPlayer.create(mContext, R.raw.a15); }
        		if(a16 == null){a16 = MediaPlayer.create(mContext, R.raw.a16); }
        		if(a17 == null){a17 = MediaPlayer.create(mContext, R.raw.a17); }
        		if(a18 == null){a18 = MediaPlayer.create(mContext, R.raw.a18); }
        		if(a19 == null){a19 = MediaPlayer.create(mContext, R.raw.a19); }
        		if(a20 == null){a20 = MediaPlayer.create(mContext, R.raw.a20); }
        		if(i == 1){ a1.start();}
    			if(i == 2){ a2.start();}
    			if(i == 3){ a3.start();}
    			if(i == 4){ a4.start();}
    			if(i == 5){ a5.start();}
    			if(i == 6){ a6.start();}
    			if(i == 7){ a7.start();}
    			if(i == 8){ a8.start();}	
    			if(i == 9){ a9.start();}
    			if(i == 10){ a10.start();}
    			if(i == 11){ a11.start();}
    			if(i == 12){ a12.start();}
    			if(i == 13){ a13.start();}
    			if(i == 14){ a14.start();}
    			if(i == 15){ a15.start();}
    			if(i == 16){ a16.start();}
    			if(i == 17){ a17.start();}
    			if(i == 18){ a18.start();}
    			if(i == 19){ a19.start();}
    			if(i == 20){ a20.start();}
    			
    			
    			
    			
        		
        		
        		
        		
        	}
        	
        	
        	
        	public String getlower(int i){
        		
        	if(i == 1) {return "a";}
        	if(i == 2) {return "b";}
        	if(i == 3) {return "c";}
        	if(i == 4) {return "d";}
        	if(i == 5) {return "e";}
        	if(i == 6) {return "f";}
        	if(i == 7) {return "g";}
        	if(i == 8) {return "h";}
        	if(i == 9) {return "i";}
        	if(i == 10) {return "j";}
        	if(i == 11) {return "k";}
        	if(i == 12) {return "l";}
        	if(i == 13) {return "m";}
        	if(i == 14) {return "n";}
        	if(i == 15) {return "o";}
        	if(i == 16) {return "p";}
        	if(i == 17) {return "q";}
        	if(i == 18) {return "r";}
        	if(i == 19) {return "s";}
        	if(i == 20) {return "t";}
        	if(i == 21) {return "u";}
        	if(i == 22) {return "v";}
        	if(i == 23) {return "w";}
        	if(i == 24) {return "x";}
        	if(i == 25) {return "y";}
        	if(i == 26) {return "z";}
        		
        	
        	
        	return "a";
        	
        	}
        	
        	
        	public String getupper(int i){
        		
        	if(i == 1) {return "A";}
        	if(i == 2) {return "B";}
        	if(i == 3) {return "C";}
        	if(i == 4) {return "D";}
        	if(i == 5) {return "E";}
        	if(i == 6) {return "F";}
        	if(i == 7) {return "G";}
        	if(i == 8) {return "H";}
        	if(i == 9) {return "I";}
        	if(i == 10) {return "J";}
        	if(i == 11) {return "K";}
        	if(i == 12) {return "L";}
        	if(i == 13) {return "M";}
        	if(i == 14) {return "N";}
        	if(i == 15) {return "O";}
        	if(i == 16) {return "P";}
        	if(i == 17) {return "Q";}
        	if(i == 18) {return "R";}
        	if(i == 19) {return "S";}
        	if(i == 20) {return "T";}
        	if(i == 21) {return "U";}
        	if(i == 22) {return "V";}
        	if(i == 23) {return "W";}
        	if(i == 24) {return "X";}
        	if(i == 25) {return "Y";}
        	if(i == 26) {return "Z";}
        		
        	
        	
        	return "A";
        	
        	}
        	
        	
        	/*if(seb == null || seb.getDuration() < 2){ seb = MediaPlayer.create(mContext, R.raw.b); } 
				if(sec == null || sec.getDuration() < 2) {sec = MediaPlayer.create(mContext, R.raw.c); }
				if(sed == null || sed.getDuration() < 2){sed = MediaPlayer.create(mContext, R.raw.d); }
				if(see == null || see.getDuration() < 2){see = MediaPlayer.create(mContext, R.raw.e); }
				if(sef == null || sef.getDuration() < 2){sef = MediaPlayer.create(mContext, R.raw.f);} 
				if(seg == null || seg.getDuration() < 2){seg = MediaPlayer.create(mContext, R.raw.g);} 
				if(seh == null || seh.getDuration() < 2){seh = MediaPlayer.create(mContext, R.raw.h);} 
				if(sei == null || sei.getDuration() < 2){sei = MediaPlayer.create(mContext, R.raw.i);} 
				if(sej == null || sej.getDuration() < 2){sej = MediaPlayer.create(mContext, R.raw.j); }
				if(sek == null || sek.getDuration() < 2){sek = MediaPlayer.create(mContext, R.raw.k); }
				if(sel == null || sel.getDuration() < 2){sel = MediaPlayer.create(mContext, R.raw.l); }
				if(sem == null || sem.getDuration() < 2){sem = MediaPlayer.create(mContext, R.raw.m); }
				if(sen == null || sen.getDuration() < 2){sen = MediaPlayer.create(mContext, R.raw.n); }
				if(seo == null || seo.getDuration() < 2){seo = MediaPlayer.create(mContext, R.raw.o); }
				if(sep == null || sep.getDuration() < 2){sep = MediaPlayer.create(mContext, R.raw.p); }
				if(seq == null || seq.getDuration() < 2){seq = MediaPlayer.create(mContext, R.raw.q); }
				if(ser == null || ser.getDuration() < 2){ser = MediaPlayer.create(mContext, R.raw.r); }
				if(ses == null || ses.getDuration() < 2){ses = MediaPlayer.create(mContext, R.raw.s); }
				if(set == null || set.getDuration() < 2){set = MediaPlayer.create(mContext, R.raw.t); }
				if(seu == null || seu.getDuration() < 2){seu = MediaPlayer.create(mContext, R.raw.u); }
				if(sev == null || sev.getDuration() < 2){sev = MediaPlayer.create(mContext, R.raw.v); }
				if(sew == null || sew.getDuration() < 2){sew = MediaPlayer.create(mContext, R.raw.w); }
				if(sex == null || sex.getDuration() < 2){sex = MediaPlayer.create(mContext, R.raw.x); }
				if(sey == null || sey.getDuration() < 2){sey = MediaPlayer.create(mContext, R.raw.y); }
				if(sez == null || sez.getDuration() < 2){sez = MediaPlayer.create(mContext, R.raw.z); }
				*/
        	
        	
        	public void playse(String ss){
        	
        		MediaPlayer tempse;
        		
        		if(tse1 == null){tempse = tse1;}
        		else{if(tse2 == null){tempse = tse2;}
        		else{if(tse3 == null){tempse = tse3;}
        		else{if(tse4== null){tempse = tse4;}}}}
        		
        		if(ss == "oops"){ tempse =  MediaPlayer.create(mContext, R.raw.seoops); tempse.start();}
        		
        		
        		
        	        		
        		
        	}
        	
        	
       public void playword(String ss){
    	   
    	   if(ss == "find"){tsound = MediaPlayer.create(mContext,  R.raw.sfind); tsound.start(); } 
    	   
    	   if(ss == "a"){  tsound = MediaPlayer.create(mContext, R.raw.a); tsound.start();}
    	   
    	   if(ss == "b"){  tsound = MediaPlayer.create(mContext, R.raw.b); tsound.start();}
    	   if(ss == "c"){  tsound = MediaPlayer.create(mContext, R.raw.c); tsound.start();}
    	   if(ss == "d"){  tsound = MediaPlayer.create(mContext, R.raw.d); tsound.start();}
    	   if(ss == "e"){  tsound = MediaPlayer.create(mContext, R.raw.e); tsound.start();}
    	   if(ss == "f"){  tsound = MediaPlayer.create(mContext, R.raw.f); tsound.start();}
    	   if(ss == "g"){  tsound = MediaPlayer.create(mContext, R.raw.g); tsound.start();}
    	   if(ss == "h"){  tsound = MediaPlayer.create(mContext, R.raw.h); tsound.start();}
    	   if(ss == "i"){  tsound = MediaPlayer.create(mContext, R.raw.i); tsound.start();}
    	   if(ss == "j"){  tsound = MediaPlayer.create(mContext, R.raw.j); tsound.start();}
    	   if(ss == "k"){  tsound = MediaPlayer.create(mContext, R.raw.k); tsound.start();}
    	   if(ss == "l"){  tsound = MediaPlayer.create(mContext, R.raw.l); tsound.start();}
    	   if(ss == "m"){  tsound = MediaPlayer.create(mContext, R.raw.m); tsound.start();}
    	   if(ss == "n"){  tsound = MediaPlayer.create(mContext, R.raw.n); tsound.start();}
    	   if(ss == "o"){  tsound = MediaPlayer.create(mContext, R.raw.o); tsound.start();}
    	   if(ss == "p"){  tsound = MediaPlayer.create(mContext, R.raw.p); tsound.start();}
    	   if(ss == "q"){  tsound = MediaPlayer.create(mContext, R.raw.q); tsound.start();}
    	   if(ss == "r"){  tsound = MediaPlayer.create(mContext, R.raw.r); tsound.start();}
    	   if(ss == "s"){  tsound = MediaPlayer.create(mContext, R.raw.s); tsound.start();}
    	   if(ss == "t"){  tsound = MediaPlayer.create(mContext, R.raw.t); tsound.start();}
    	   if(ss == "u"){  tsound = MediaPlayer.create(mContext, R.raw.u); tsound.start();}
    	   if(ss == "v"){  tsound = MediaPlayer.create(mContext, R.raw.v); tsound.start();}
    	   if(ss == "w"){  tsound = MediaPlayer.create(mContext, R.raw.w); tsound.start();}
    	   if(ss == "x"){  tsound = MediaPlayer.create(mContext, R.raw.x); tsound.start();}
    	   if(ss == "y"){  tsound = MediaPlayer.create(mContext, R.raw.y); tsound.start();}
    	   if(ss == "z"){  tsound = MediaPlayer.create(mContext, R.raw.z); tsound.start();}
    	   
    	   
    	   if(ss == "sethatsright"){tsound = MediaPlayer.create(mContext,  R.raw.sethatsright); tsound.start();}
    	   if(ss == "secorrect"){tsound = MediaPlayer.create(mContext,  R.raw.secorrect); tsound.start();}
    	   if(ss == "seoops"){tsound = MediaPlayer.create(mContext,  R.raw.seoops); tsound.start();}
    	   if(ss == "senicework"){tsound = MediaPlayer.create(mContext,  R.raw.senicework); tsound.start();}
    	   if(ss == "segoodjob"){tsound = MediaPlayer.create(mContext,  R.raw.segoodjob); tsound.start();}
    	   if(ss == "seclapping"){tsound = MediaPlayer.create(mContext,  R.raw.seclapping); tsound.start();}
    	   if(ss == "seexcellent"){tsound = MediaPlayer.create(mContext,  R.raw.seexcellent); tsound.start();}
    	   
    	   
    	   
       }
        	
        	
        	
        	
        	
        	
        	
        	
        	
        	
        	public void clearstuff(){
		synchronized(mSprites){
        			
        			mSprites.clear();
        			
        			
        		}
        		  
		
		
        	   		synchronized(lsprites){
        	   
            lsprites.clear();
        	   		}
        		
        		
        		synchronized(abcmenu){
        			abcmenu.clear();
        			
        		}
        		
        	abccorrect = 0;
        	}
        	
        	
        	
        	
        /**
         * Figures the lander state (x, y, fuel, ...) based on the passage of
         * realtime. Does not invalidate(). Called at the start of draw().
         * Detects the end-of-game and sets the UI to the next state.
         */
        private void updatePhysics() {
            long now = System.currentTimeMillis();
            
            // Do nothing if mLastTime is in the future.
            // This allows the game-start to delay the start of the physics
            // by 100ms or whatever.
           
 
            pause = pause -1;
            if(pause < 0){pause = 0;}
            
            if (pause > 0) {return;}
            if (mLastTime > now) return;
       	
            
            if(menubuttonloaded == false){
            	
            	if(mmenu == null){ mmenu = BitmapFactory.decodeStream(res.openRawResource(R.drawable.mmenu)); 
            	mmenu = Bitmap.createScaledBitmap(mmenu, gw(mmenu.getWidth()), gh(mmenu.getHeight()), false);
            	}
            	
            	amenu.Initialize(mmenu, mmenu.getHeight(), mmenu.getWidth(),24, 1, true);
            	amenu.setXPos(amenu.getWidth()/2);
            	amenu.setYPos(amenu.getHeight()/2);
            	
            	
            	menubuttonloaded = true;

            	
            	spacer = gw(20);
            	
            	
            	
    			if(mred == null){mred = BitmapFactory.decodeStream(res.openRawResource(R.drawable.mred)); 
    			mred = Bitmap.createScaledBitmap(mred, gw(mred.getWidth()), gh(mred.getHeight()), false);}
    			
    			if(mgreen == null){mgreen = BitmapFactory.decodeStream(res.openRawResource(R.drawable.mgreen)); 
    			mgreen = Bitmap.createScaledBitmap(mgreen, gw(mgreen.getWidth()), gh(mgreen.getHeight()), false);}
        		
               		
    			if(bgred == null){bgred= BitmapFactory.decodeStream(res.openRawResource(R.drawable.bgred));
    			bgred = Bitmap.createScaledBitmap(bgred, gw(bgred.getWidth()), gh(bgred.getHeight()), false);
    			}
    			if(bggreen == null){bggreen= BitmapFactory.decodeStream(res.openRawResource(R.drawable.bggreen));
    			bggreen = Bitmap.createScaledBitmap(bggreen, gw(bggreen.getWidth()), gh(bggreen.getHeight()), false);
    			}
    			if(bgreds == null){bgreds= BitmapFactory.decodeStream(res.openRawResource(R.drawable.bgreds));
    			bgreds = Bitmap.createScaledBitmap(bgreds, gw(bgreds.getWidth()), gh(bgreds.getHeight()), false);
    			}
    			if(bggreens == null){bggreens= BitmapFactory.decodeStream(res.openRawResource(R.drawable.bggreens));
    			bggreens = Bitmap.createScaledBitmap(bggreens, gw(bggreens.getWidth()), gh(bggreens.getHeight()), false);
    			}
    			
    		
            	
            	if(outline == null){ outline = BitmapFactory.decodeStream(res.openRawResource(R.drawable.outline)); 
            	outline = Bitmap.createScaledBitmap(outline, gw(outline.getWidth()), gh(outline.getHeight()), false);
            	}
      
            
            	
        		if(blevelred == null){blevelred = BitmapFactory.decodeStream(res.openRawResource(R.drawable.blevelred)); 
    			blevelred = Bitmap.createScaledBitmap(blevelred, gw(blevelred.getWidth()), gh(blevelred.getHeight()), false);
    			}
    			if(blevelgreen == null){blevelgreen = BitmapFactory.decodeStream(res.openRawResource(R.drawable.blevelgreen)); 
    			
    			blevelgreen = Bitmap.createScaledBitmap(blevelgreen, gw(blevelgreen.getWidth()), gh(blevelgreen.getHeight()), false);
    			}
        	
    			
            		
            	 if(apple == null){apple = BitmapFactory.decodeStream(res.openRawResource(R.drawable.apple)); 
            		apple = Bitmap.createScaledBitmap(apple, gw(apple.getWidth()), gh(apple.getHeight()), false);
                    	 
            	 }
            	
            	
            	
            	
if(igreen100 == null)
        			
        		{
        			igreen100 = BitmapFactory.decodeStream(res.openRawResource(R.drawable.green100));
        			igreen100 = Bitmap.createScaledBitmap(igreen100, gw(igreen100.getWidth()), gh(igreen100.getHeight()), false);
        		}
        		
        			if(ired100 == null){
        				ired100  =BitmapFactory.decodeStream(res.openRawResource(R.drawable.red100));
        				ired100 = Bitmap.createScaledBitmap(ired100, gw(ired100.getWidth()), gh(ired100.getHeight()), false);
        				
        			}
        			if(smile == null){
        		smile  =BitmapFactory.decodeStream(res.openRawResource(R.drawable.smile));
        		smile = Bitmap.createScaledBitmap(smile, gw(smile.getWidth()), gh(smile.getHeight()), false);
        				
        			}
            		

        			
        	    
		if(igreen == null)
            			
            		{
            			
            			igreen = BitmapFactory.decodeStream(res.openRawResource(R.drawable.green));
            			igreen = Bitmap.createScaledBitmap(igreen, gw(igreen.getWidth()), gh(igreen.getHeight()), false);
            		}
            		
            			if(ired == null){
            				ired  =BitmapFactory.decodeStream(res.openRawResource(R.drawable.red));
            				ired = Bitmap.createScaledBitmap(ired, gw(ired.getWidth()), gh(ired.getHeight()), false);
            			}		
            	
            			if(iconbg == null){		iconbg  = BitmapFactory.decodeStream(res.openRawResource(R.drawable.iconbg));
            			iconbg = Bitmap.createScaledBitmap(iconbg, gw(iconbg.getWidth()), gh(iconbg.getHeight()), false);
        	}
            
            			
            			
            			levelbuttonsoffset = spacer *3 + blevelgreen.getWidth()* 2 + blevelgreen.getWidth()/2;

            	   		amenuoffset  = amenu.getWidth() + blevelred.getWidth()/2 + spacer;
            	   	
            	   		topmenuoffset = iconbg.getHeight()*2 + 3*spacer;	
            	   
            			
            			
            }
        //    synchronized(mSprites){
            
           //  	if(setup == 0){
            		
            //		clearstuff();
            		
            	//}
           
          //   	     }
             	
            if(tse1 != null){         if(tse1.isPlaying()== false){tse1.release(); tse1=  null;} }

            if(tse2 != null){ if(tse2.isPlaying()== false){tse2.release(); tse2=  null;} }

            if(tse3 != null){ if(tse3.isPlaying()== false){tse3.release(); tse3=  null;} }	

            if(tse4 != null){ if(tse4.isPlaying()== false){tse4.release(); tse4=  null;} }
                        
            
            
            synchronized(words){
            
            if(words.isEmpty() == false){
            	
            	AnimatedSprite tester = words.get(0);
            	
            	
            	if(tester.delay == tester.maxdelay )
            	{
            	playword((tester.word));
            	tester.delay--;
            	}
            	
            	if(tsound.isPlaying() == false){
            	
            tester.delay--;
            if(tester.delay < 1){
            	tsound.release();
            	tsound = null;
            	words.remove(tester);
            }            	
            }
            	
            }
             	
            }
            
             	if(tsound != null){
             if(tsound.isPlaying() == true || words.isEmpty()== false){return;}	
             }
             	
             	
             	
            	if(gamechange == true){
             		clearstuff();
             		gamechange = false;
             	}
             	
             
             	
            if(setup == 0){    		
    			
    				
           
            	clearstuff();
            	
            	showmenu();
            	
          
    		}
            
            
           
            
             		
       		if(setup == 2){
       			
       	
       			setupgetit();
       			setup =1;
       			cgame = 2;
       			
       		}
            
            
       		if(setup == 3){
       			
       	
       			
       			setupchaseit();
       			setup = 1;
       			cgame = 3;
       			
       		}
       		
      
       		
       		if(setup == 4){
     
       		setupdragit();
       		cgame = 4;
       		setup = 1;
        }
       		if(setup == 5){
       
       		setupmatchit();
       		setup = 1;
       		cgame =5;
        }
       		if(setup == 6){
       			
       			
       			
       	
       			setupcountit();
       			setup = 1;
       			cgame = 6;
       			
       		}
       		
       		if(setup == 7){
       		level = 1;
       			cgame = 7;
       		setupabcs();
       			setup = 1;
       			
       	
       		}  
       		
       		if(setup == 8){
       			cgame = 8;
       			level =2;
       		
       		setupabcs();
       		
       		setup = 1;
       		
       		}
       		
       		
    		if(setup == 9){
    			level = 3;
   			cgame = 9;
       		setupabcs();
       		setup = 1;
       		
       		}
    		if(setup == 10){
    			level = 4;
   			cgame = 10;
       		setupabcs();
       		setup = 1;
       		
       		}
    		
    		if(setup == 11){
    			level = 5;
   			cgame = 11;
       		setupabcs();
       		setup = 1;
       		
       		}
       		
       		if(setup == 12){
    			level = 6;
   			cgame = 12;
       		setupabcs();
       		setup = 1;
       		
       		}	
       		
       
        
       		
       		if(cgame ==2) {handlegetit();}
       		if(cgame ==3) {handlechaseit();}
       		if(cgame ==4) {handledragit();}
       		//if(cgame ==5) {handlematchit();}
       		//if(cgame == 6) {handlecountit();}
       		
    
       		
     
          
            
            
            synchronized(mSpritestoRemove){
            synchronized(mSprites){
	            for( AnimatedSprite a : mSprites){
	            	a.Update(now);
	            	
	            	if(a.dispose)
	            		mSpritestoRemove.add(a);            	
	            }
            }
            }
            
            synchronized(mSprites){
            synchronized(mSpritestoRemove){
	            mSprites.removeAll(mSpritestoRemove); 
	            mSpritestoRemove.clear();
            }
            }
            
            
            
            
            
            numSprites = mSprites.size();
            mLastTime = now;

        }
        
        public float distance(float x1, float y1, float x2, float y2){
        	
        	
        	
        	return (float) ( Math.sqrt((double)(          (x1 - x2) * (x1 - x2) + (y1 - y2) *(y1 - y2)  )));
        	
        	
        }
        
        public void checkmenu(float x, float y){
        	
        	
        	
        	
        	
        	int idd = 0;
        	
        	synchronized(mSprites){
        	for (AnimatedSprite a : mSprites){
        		
        		
        		
        		if(a.recthit(x,y)){
        			
        			
        			
        			idd = a.id;
        			
        		}
        		
        		
        		
        		
        	}
        	}
        	
        	if(idd != 0) {
        		
        		gamechange = true; loadgame(idd);
        		
        	}
        	
        	
        	
        }
        
        
        public void checktouchgetit(MotionEvent event){
        	
            float x = event.getX();  // or getRawX();
            float y = event.getY();
            int action = event.getAction();
            switch(action){
            case MotionEvent.ACTION_DOWN:
            	if(mMode != STATE_RUNNING)
            		setState(STATE_RUNNING);
            	else if(mMode == STATE_RUNNING){
            	
            		int flag = 0;
            		
            		synchronized(mSprites){
            		
            	 	for( AnimatedSprite a : mSprites){
            	 		
            	 		
            	 		
                
            	 		float dd = distance((float)a.getXPos(), (float)a.getYPos(), x - (float) a.getWidth() /2,y - (float) a.getHeight() /2);
            	 		
            	 		if(dd < igreen100.getWidth() /2){
            	 			
            	 			flag =1;
            	 		
            	 		  		
            	 			//inc score if green, dec score if red.
            	 			
            	 			if(a.mycolor == 1){
            	 				score = score +1;
            	 				
            	 				
            	 				
            	 				if(getitright1.isPlaying() ==false ){ getitright1.start();}	
            	 				else {if(getitright2.isPlaying() ==false ){ getitright2.start();}
            	 				else {if(getitright3.isPlaying() ==false ){ getitright3.start();}
            	 				else {if(getitright4.isPlaying() ==false ){ getitright4.start();}
            	 				}}}
            	 				
            	 				
            	 				
            	 			}else{
            	 				
            	 				score = score -2;
            	 				if(score < 0){score = 0;}
            	 				
            	 				playse("oops");
            	 				
            	 				if(getitwrong1.isPlaying() ==false ){ getitwrong1.start();}	
            	 				else {if(getitwrong2.isPlaying() ==false ){ getitwrong2.start();}
            	 				else {if(getitwrong3.isPlaying() ==false ){ getitwrong3.start();}
            	 				else {if(getitwrong4.isPlaying() ==false ){ getitwrong4.start();}
            	 				}}}
            	 				
            	 				
            	 			}
            	 			
            	 			
            	 			
            	 		a.dispose = true;
            	 		
            	 		
            	 			
            	 		}
            	 		
                	} 
            	 	
            		}
            	 	if(flag ==1){
            
            	 			
            	 			addnew();
            	 		
            		
            	 	}
            		
            	         	
            	break;
            }
        	}
        	
        	
        	
        }
        
        
public void checktouchchaseit(MotionEvent event){
  	
    float x = event.getX();  // or getRawX();
    float y = event.getY();
    tx = x;
    ty = y;
		int action = event.getAction();
    switch(action){
    
    
    case MotionEvent.ACTION_UP:
    	if(mMode != STATE_RUNNING)
    		setState(STATE_RUNNING);
    	else if(mMode == STATE_RUNNING){
    	

    		touchdown = false;
    		movedot = false;
    		
    			
    	}     	
    	break;
    	
    	
    case MotionEvent.ACTION_DOWN:
    	if(mMode != STATE_RUNNING)
    		setState(STATE_RUNNING);
    	else if(mMode == STATE_RUNNING){
    	
    		touchdown = true;
        		movedot = true;
    		
    		
    		
    	
    		
    	}     	
    	break;
    	
    	case MotionEvent.ACTION_MOVE:
    	if(mMode != STATE_RUNNING)
    		setState(STATE_RUNNING);
    	else if(mMode == STATE_RUNNING){
    	
 	
    		float dd = distance((float)aaa.getXPos(), (float)aaa.getYPos(), x - (float) aaa.getWidth() /2,y - (float) aaa.getHeight() /2);
    		
    		if(dd < aaa.getWidth() /2){
    			
    			
    			
    			movedot = true;
    			
    		}
    		else{movedot = false;}
    		
    		
    		
    	}
    	break;
    	
	}
	
	
}

public void checktouchcountit(MotionEvent event){
	
	
	
	
	
	
	
	
		if(a1 == null){a1 = MediaPlayer.create(mContext, R.raw.a1); }
		if(a2 == null){a2 = MediaPlayer.create(mContext, R.raw.a2); }
		if(a3== null){a3 = MediaPlayer.create(mContext, R.raw.a3); }
		if(a4 == null){a4 = MediaPlayer.create(mContext, R.raw.a4); }
		if(a5 == null){a5 = MediaPlayer.create(mContext, R.raw.a5); }
		if(a6 == null){a6 = MediaPlayer.create(mContext, R.raw.a6); }
		if(a7 == null){a7 = MediaPlayer.create(mContext, R.raw.a7); }
		if(a8 == null){a8 = MediaPlayer.create(mContext, R.raw.a8); }
		if(a9 == null){a9 = MediaPlayer.create(mContext, R.raw.a9); }
		
  	
    float x = event.getX();  // or getRawX();
    float y = event.getY();
    tx = x;
    ty = y;

	
	
	int idd = 0;
	

	synchronized(mSprites){
		if(MotionEvent.ACTION_DOWN == event.getAction()){
	int flag  =0;
	for (AnimatedSprite a : mSprites){
		
		
		if(a.recthit(x,y)){
			idd = a.id;
			
			if( numobj == idd){
				
				
				playcorrect();
			//	 AnimatedSprite zzz = new AnimatedSprite();
            //	 zzz.word = "secorrect";
            //	 zzz.setdelay(10);
            //	 words.add(zzz);
    			
			 flag = 1;} else{
				
				if(idd < 10){
					
		//			playoops();
									
				}
				
				
			}  
			
			
			if(idd > 200 && flag == 0){ 
			a.textoffset = gw(17); a.textsize = gw(a.textsize);	a.textcolor = Color.WHITE; a.ffont = myfont; a.hastext =true; a.mytext = Integer.toString(currentnumber); a.id = 100;
			
			if(currentnumber == 1){ a1.start();}
			if(currentnumber == 2){ a2.start();}
			if(currentnumber == 3){ a3.start();}
			if(currentnumber == 4){ a4.start();}
			if(currentnumber == 5){ a5.start();}
			if(currentnumber == 6){ a6.start();}
			if(currentnumber == 7){ a7.start();}
			if(currentnumber == 8){ a8.start();}	
			if(currentnumber == 9){ a9.start();}
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			currentnumber++; }
	//play appro number sound
				
		
			
			
		}
		
		
		
		
	}
	
	if(flag == 1){loadcountitlevel(1);}
	
	}
	
	
	}
	
	

	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
}



public void checktouchdragit(MotionEvent event){

float x = event.getX();  // or getRawX();
float y = event.getY();
tx = x;
ty = y;
	int action = event.getAction();
switch(action){


case MotionEvent.ACTION_UP:
	if(mMode != STATE_RUNNING)
		setState(STATE_RUNNING);
	else if(mMode == STATE_RUNNING){
	

		touchdown = false;
		movedot = false;
		
			
	}     	
	break;
	
	
case MotionEvent.ACTION_DOWN:
	if(mMode != STATE_RUNNING)
		setState(STATE_RUNNING);
	else if(mMode == STATE_RUNNING){
	
		touchdown = true;
 		movedot = true;
 		float dd = distance((float)aaa.getXPos(), (float)aaa.getYPos(), x - (float) aaa.getWidth() /2,y - (float) aaa.getHeight() /2);
 		
		if(dd < aaa.getWidth()/2){
			
			playnumber(aaa.id);
			
			
		}
		
	for (AnimatedSprite a: lsprites){
		
		if(a.recthit(x, y)){
			
			if(a.id == 1){ setupdragit();}
			if(a.id == 2){ loadlevel2dragit();}
			if(a.id == 3){ loadlevel3dragit();}
			if(a.id == 4){loadlevel4dragit();}
			break;
			
		}
		
		
		
		
		
	}
		
		
		
		
		
	}     	
	break;
	
	case MotionEvent.ACTION_MOVE:
	if(mMode != STATE_RUNNING)
		setState(STATE_RUNNING);
	else if(mMode == STATE_RUNNING){
	

		float dd = distance((float)aaa.getXPos(), (float)aaa.getYPos(), x - (float) aaa.getWidth() /2,y - (float) aaa.getHeight() /2);
		
		if(dd < aaa.getWidth() /2){
	
			
			aaa.setXPos((int)x);
			aaa.setYPos((int)y);
			
			
			
			movedot = true;
			
		}
		else{movedot = false;}
		
		
		
	}
	break;
	
}


}


public void checkabctouch(MotionEvent event){
		
		

		
		 float x = event.getX();  // or getRawX();
		    float y = event.getY();
		    tx = x;
		    ty = y;
				int action = event.getAction();
				if( action == MotionEvent.ACTION_DOWN){
					
					
		if(mMode != STATE_RUNNING)
			setState(STATE_RUNNING);
		else if(mMode == STATE_RUNNING){
		
			touchdown = true;
	    		movedot = true;

	    		int done = 0;
	    		
	    		for (AnimatedSprite a: lsprites){
	    			
	    			if(a.recthit(x, y)){
	    				
	    				pause = 0;
	    				if(a.id == 1){ setup =7;}
	    				if(a.id == 2){ setup = 8;}
	    				if(a.id == 3){ setup = 9;}
	    				if(a.id == 4){ setup = 10;}
	    				if(a.id == 5){ setup = 11;}
	    				if(a.id == 6){ setup = 12;}
	    				
	    				abccorrect = 0;
	    				gamechange = true;
	    				break;
	    				
	    			}
	       		}	    		
	    		
	   synchronized(mSprites){
	    for(AnimatedSprite a : mSprites){
	    		
	    	if(a.recthit(x,y)){
	    			
	    		if(a.id == ans ){
	    			
	    			
	    			if(a.isgreen == false){
	    					//correct congrats and make new question.
	    					playcorrect();
	    					
	    					if( level < 4 && level > 0){
	    					a.animation = bggreen;
	    					}
	    					else{ if (level <7 && level > 3){
	    					a.animation = bggreens;	
	    						
	    					}
	    					}
	    					done = 1;
	    					abccorrect++;
	    				a.isgreen = true;
	    				synchronized(abcmenu){
	    					for (AnimatedSprite abc: abcmenu){
	    				
	    						if(abc.id == ans){
	    							abc.animation = blevelgreen;
	    							abc.mycolor = 1;
	    						}
	    					}
	    				}
	    			}
	    		}
	    		else{
	    			//play oops
	    			playoops();
	    		}
	    	}
	      		
	    }
	    	
	   }//end synch
	    	
	    	if(done == 1){
	     
	    	pause = 20;
	    	
	    	
	    	switch(level){
	    	
	    	
	    	case 1:
	    		setup = 7; cgame = 7;
	    		break;
	    	case 2:
	    		setup = 8; cgame = 8;
	    		break;
	    	
	    	case 3:
	    		setup = 9; cgame = 9;
	    		break;
	    	
	    	case 4:
	    		setup = 10; cgame = 10;
	    		break;
	    	
	    	case 5:
	    		setup = 11; cgame = 11;
	    		break;
	    	
	    	case 6:
	    		setup =12; cgame = 12;
	    		break;
	    	
	    	
	    	
	    	
	    	}
	    	
	    	}
		} // end state running.
	}
	
}




public void checktouchmatchit(MotionEvent event){
	
	int flag = 0;
	float x = event.getX();
	float y = event.getY();
	int action = event.getAction();
	switch(action){
	
	 case MotionEvent.ACTION_DOWN:
     	if(mMode != STATE_RUNNING)
     		setState(STATE_RUNNING);
     	else if(mMode == STATE_RUNNING){
     		synchronized(mSprites){
     		
     			for( AnimatedSprite a : mSprites){
     	
     			if(a.recthit(x, y)){ 
     			if(a.id == otratype){
     				//play correct;
     			playcorrect();	
     				flag = 1;
     			
     			// make new question	
     				
     			}else{
     			//play incorrect oops	
     			playoops();
     				
     				//soops.start();
     			}
     				
     			 }
     	}
	
	
	
	}
     		
     		if(flag == 1){		makematchitquestion();}
     		
	
     	}
	
}
	}

public void touchcheckmenu(MotionEvent event){
	
	 float x = event.getX();  // or getRawX();
	    float y = event.getY();
	    tx = x;
	    ty = y;
			int action = event.getAction();
			if( action == MotionEvent.ACTION_DOWN){
				
				
	if(mMode != STATE_RUNNING)
		setState(STATE_RUNNING);
	else if(mMode == STATE_RUNNING){
	
		touchdown = true;
    		movedot = true;

			
		if(amenu.recthit(x, y)){  
		
			pause = 0; setup = 0; cgame = 0; }
		
			
		if(setup == 1 && cgame == 0){
		
			
			checkmenu(tx,ty); }    
     
	}
			}
}







        /**
         * Detected touch event
         * @param e
         */
        public Boolean doTouch(MotionEvent event){
        	
   
        	
 
      
            		if(cgame ==2){ checktouchgetit(event);}
      
            		if(cgame == 3){checktouchchaseit(event);}
            		
            		if(cgame == 4){checktouchdragit(event);}
          
            		if(cgame == 5){checktouchmatchit(event);}
            		if(cgame == 6){checktouchcountit(event);}
            		if(cgame > 6 && cgame < 13 ){ checkabctouch(event);}
            		
                   touchcheckmenu(event);		
         return true;
        }
        
     
        
        /**
         * Sets the game mode. That is, whether we are running, paused, in the
         * failure state, in the victory state, etc.
         * 
         * @param mode one of the STATE_* constants
         * @param message string to add to screen or null
         */
        public void setState(int mode, CharSequence message) {
            /*
             * This method optionally can cause a text message to be displayed
             * to the user when the mode changes. Since the View that actually
             * renders that text is part of the main View hierarchy and not
             * owned by this thread, we can't touch the state of that View.
             * Instead we use a Message + Handler to relay commands to the main
             * thread, which updates the user-text View.
             */
            synchronized (mSurfaceHolder) {
                mMode = mode;

                if (mMode == STATE_RUNNING) {
                    Message msg = mHandler.obtainMessage();
                    Bundle b = new Bundle();
                    b.putString("text", "");
                    b.putInt("viz", View.INVISIBLE);
                    msg.setData(b);
                    mHandler.sendMessage(msg);
                } else {
                   
                    Resources res = mContext.getResources();
                    CharSequence str = "";
                    if (mMode == STATE_READY)
                        str = res.getText(R.string.mode_ready);
                    else if (mMode == STATE_PAUSE)
                        str = res.getText(R.string.mode_pause);
                    else if (mMode == STATE_LOSE)
                        str = res.getText(R.string.mode_lose);
                    else if (mMode == STATE_WIN)
                        str = res.getString(R.string.mode_win_prefix)
                                + numSprites + " "
                                + res.getString(R.string.mode_win_suffix);

                    if (message != null) {
                        str = message + "\n" + str;
                    }

                    if (mMode == STATE_LOSE) numSprites = 0;

                    Message msg = mHandler.obtainMessage();
                    Bundle b = new Bundle();
                    b.putString("text", str.toString());
                    b.putInt("viz", View.VISIBLE);
                    msg.setData(b);
                    mHandler.sendMessage(msg);
                }
            }
        }
        
        /**
         * Dump game state to the provided Bundle. Typically called when the
         * Activity is being suspended.
         * 
         * @return Bundle with this view's state
         */
        public Bundle saveState(Bundle map) {
            synchronized (mSurfaceHolder) {
                if (map != null) {
                    map.putInt(KEY_DIFFICULTY, Integer.valueOf(mDifficulty));                    
                    map.putInt(KEY_WINS, Integer.valueOf(numSprites));
                }
            }
            return map;
        }

        /**
         * Sets the current difficulty.
         * 
         * @param difficulty
         */
        public void setDifficulty(int difficulty) {
            synchronized (mSurfaceHolder) {
                mDifficulty = difficulty;
            }
        }

        /**
         * Used to signal the thread whether it should be running or not.
         * Passing true allows the thread to run; passing false will shut it
         * down if it's already running. Calling start() after this was most
         * recently called with false will result in an immediate shutdown.
         * 
         * @param b true to run, false to shut down
         */
        public void setRunning(boolean b) {
            mRun = b;
        }

        /**
         * Sets the game mode. That is, whether we are running, paused, in the
         * failure state, in the victory state, etc.
         * 
         * @see #setState(int, CharSequence)
         * @param mode one of the STATE_* constants
         */
        public void setState(int mode) {
            synchronized (mSurfaceHolder) {
                setState(mode, null);
            }
        }

        /* Callback invoked when the surface dimensions change. */
        public void setSurfaceSize(int width, int height) {
            // synchronized to make sure these all change atomically
            synchronized (mSurfaceHolder) {


            }
        }

        /**
         * Resumes from a pause.
         */
        public void unpause() {
            // Move the real time clock up to now
            synchronized (mSurfaceHolder) {
                mLastTime = System.currentTimeMillis() + 100;
            }
            setState(STATE_RUNNING);
        }
        
        /**
         * Starts the game, setting parameters for the current difficulty.
         */
        public void doStart() {
            synchronized (mSurfaceHolder) {               
                mLastTime = System.currentTimeMillis() + 100;
                setState(STATE_RUNNING);
            }
        }

        /**
         * Pauses the physics update & animation.
         */
        public void pause() {
            synchronized (mSurfaceHolder) {
                if (mMode == STATE_RUNNING) setState(STATE_PAUSE);
            }
        }

        /**
         * Restores game state from the indicated Bundle. Typically called when
         * the Activity is being restored after having been previously
         * destroyed.
         * 
         * @param savedState Bundle containing the game state
         */
        public synchronized void restoreState(Bundle savedState) {
            synchronized (mSurfaceHolder) {
                setState(STATE_PAUSE);         

                cgame = 0; setup =0;
              //  mDifficulty = savedState.getInt(KEY_DIFFICULTY);               
              //  numSprites = savedState.getInt(KEY_WINS);
            }
        }

		public void clearSprites() {
			synchronized(mSprites){
				mSprites.clear();			
			}
		}

        


        
    }

    /** Handle to the application context, used to e.g. fetch Drawables. */
    private Context mContext;

    /** Pointer to the text view to display "Paused.." etc. */
    private TextView mStatusText;

    /** The thread that actually draws the animation */
    private AnimationThread thread;

    public AnimationView(Context context, AttributeSet attrs) {
        super(context, attrs);

        // register our interest in hearing about changes to our surface
        SurfaceHolder holder = getHolder();
        holder.addCallback(this);

        // create thread only; it's started in surfaceCreated()
        thread = new AnimationThread(holder, context, new Handler() {
            @Override
            public void handleMessage(Message m) {
                mStatusText.setVisibility(m.getData().getInt("viz"));
                mStatusText.setText(m.getData().getString("text"));
            }
        });

        setFocusable(true); // make sure we get key events
    
    }
    
    @Override
    public boolean onTouchEvent(MotionEvent event){
    	
    	
    	
    	thread.doTouch(event);
    	
    	return true;// super.onTouchEvent(event);
    
    
    
    
    }
    
    /**
     * Fetches the animation thread corresponding to this LunarView.
     * 
     * @return the animation thread
     */
    public AnimationThread getThread() {
        return thread;
    }

    /**
     * Standard window-focus override. Notice focus lost so we can pause on
     * focus lost. e.g. user switches to take a call.
     */
    @Override
    public void onWindowFocusChanged(boolean hasWindowFocus) {
        if (!hasWindowFocus) thread.pause();
    }

    /**
     * Installs a pointer to the text view used for messages.
     */
    public void setTextView(TextView textView) {

    	mStatusText = textView;
        
    }

    /* Callback invoked when the surface dimensions change. */
    public void surfaceChanged(SurfaceHolder holder, int format, int width,
            int height) {
        thread.setSurfaceSize(width, height);
    }

    /*
     * Callback invoked when the Surface has been created and is ready to be
     * used.
     */
    public void surfaceCreated(SurfaceHolder holder) {
        // start the thread here so that we don't busy-wait in run()
        // waiting for the surface to be created
   
    	
        // added fix -->
        if(thread.getState()== Thread.State.TERMINATED){
        	   // create thread only; it's started in surfaceCreated()
            thread = new AnimationThread(holder, mContext, new Handler() {
                @Override
                public void handleMessage(Message m) {
                    mStatusText.setVisibility(m.getData().getInt("viz"));
                    mStatusText.setText(m.getData().getString("text"));
                }
            });
           setFocusable(true); 
           thread.setRunning(true);
           
           thread.start();
           thread.setup = 0; 
            
    // <-- added fix
        }else{
        	thread.setRunning(true);
        
        thread.start();
    }
    }
    /*
     * Callback invoked when the Surface has been destroyed and must no longer
     * be touched. WARNING: after this method returns, the Surface/Canvas must
     * never be touched again!
     */
    public void surfaceDestroyed(SurfaceHolder holder) {
        // we have to tell thread to shut down & wait for it to finish, or else
        // it might touch the Surface after we return and explode
        boolean retry = true;
        thread.setRunning(false);
        while (retry) {
            try {
                thread.join();
                retry = false;
            } catch (InterruptedException e) {
            }
        }
    }
}
